#COMPILE EXE
#DIM ALL
#INCLUDE "WIN32API.INC"
#INCLUDE "RMChart.inc"

SUB Console (TEXT AS STRING)
  STATIC hConsole AS DWORD
  IF hConsole = 0 THEN
    ALLOCCONSOLE
    hConsole = GETSTDHANDLE(%STD_OUTPUT_HANDLE)
  END IF
  WRITEFILE hConsole, BYVAL STRPTR(TEXT), LEN(TEXT), 0, BYVAL 0
END SUB

DECLARE FUNCTION PrinterDialog1 (BYVAL DWORD, DWORD,  DWORD, WORD, WORD, WORD, BYVAL WORD, BYVAL WORD) AS LONG
DECLARE SUB ExportTheChart(BYVAL LONG, BYVAL LONG)
DECLARE FUNCTION MiniDesigner(BYVAL hParent AS LONG) AS LONG
DECLARE FUNCTION ReadColors(BYVAL nMode AS LONG, BYVAL nIndex AS LONG, BYREF sName AS STRING) AS LONG
DECLARE FUNCTION COMBOADDLINE (BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG, _
                                           BYVAL sText AS STRING, OPTIONAL BYVAL nData AS LONG) AS LONG
DECLARE SUB COMBOSETINDEXDATA(BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG, BYVAL nData AS LONG)                                           
DECLARE FUNCTION COMBOGETSELDATA (BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG) AS LONG
DECLARE FUNCTION CheckGet(BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG) AS LONG
DECLARE SUB CheckSet(BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG,BYVAL nState AS LONG)
DECLARE FUNCTION OptGet(BYVAL hDlg AS LONG, BYVAL nLower AS LONG, BYVAL nUpper AS LONG) AS LONG
DECLARE FUNCTION TRIM(BYVAL sText AS STRING) AS STRING

%ID_RMC1        = %WM_USER+1024
%ID_EXPORT      = %ID_RMC1+1
%ID_PRINT       = %ID_RMC1+2
%ID_CLOSE       = %ID_RMC1+3
%ID_GB1         = %ID_RMC1+4
%ID_GB2         = %ID_RMC1+5
%ID_GB3         = %ID_RMC1+6
%ID_GB4         = %ID_RMC1+7
%ID_GB5         = %ID_RMC1+8
%ID_GB6         = %ID_RMC1+9
%ID_GB7         = %ID_RMC1+10
%ID_GB8         = %ID_RMC1+11
%ID_GB9         = %ID_RMC1+12
%ID_GB10         = %ID_RMC1+101
%ID_NGB1        = %ID_RMC1+13
%ID_NGB2        = %ID_RMC1+14
%ID_XY1         = %ID_RMC1+20
%ID_XY2         = %ID_RMC1+21
%ID_MSC1        = %ID_RMC1+37
%ID_MSC2        = %ID_RMC1+38
%ID_MSC3        = %ID_RMC1+39
%ID_MSC4        = %ID_RMC1+40
%ID_MSC5        = %ID_RMC1+41
%ID_MSC6        = %ID_RMC1+42
%ID_MSC7        = %ID_RMC1+43
%ID_MSC8        = %ID_RMC1+44
%ID_MSC9        = %ID_RMC1+45
%ID_MSC10       = %ID_RMC1+46
%ID_SCROLL      = %ID_RMC1+60
%IDC_GRAPHIC1   = %ID_RMC1+61
%ID_RMC2        = %ID_RMC1+62
%ID_CB_COLOR    = %ID_RMC1+63
%ID_CB_COLOROBJ = %ID_RMC1+64
%ID_OPT_H       = %ID_RMC1+65  
%ID_OPT_V       = %ID_RMC1+66
%ID_OPT_FH       = %ID_RMC1+67
%ID_OPT_SH       = %ID_RMC1+68
%ID_CB_S1STYLE   = %ID_RMC1+69
%ID_CB_S2STYLE   = %ID_RMC1+71
%ID_CHK_S1HIDE   = %ID_RMC1+72
%ID_CHK_S2HIDE   = %ID_RMC1+73
%ID_CHK_S1VLABEL = %ID_RMC1+74
%ID_CHK_S2VLABEL = %ID_RMC1+75
%ID_CHK_LUCENT   = %ID_RMC1+76
%ID_CB_LSTYLE    = %ID_RMC1+77
%ID_CB_SYMBOLS   = %ID_RMC1+78
%ID_LBL_LSTYLE   = %ID_RMC1+79
%ID_LBL_SYMBOLS  = %ID_RMC1+80
%ID_CHK_CLONE    = %ID_RMC1+81
%ID_OPT_JPG      = %ID_RMC1+82
%ID_OPT_EMF      = %ID_RMC1+83
%ID_CMD_PRINT    = %ID_RMC1+84
%ID_CMD_SAVE     = %ID_RMC1+85
%ID_CMD_COPY     = %ID_RMC1+86
%ID_INFO         = %ID_RMC1+87
%ID_CHK_TOOLTIPS = %ID_RMC1+89
%ID_RMC3         = %ID_RMC1+100
%WM_TIMER        = &H113

GLOBAL siH          AS SCROLLINFO
GLOBAL lScrH        AS LONG
GLOBAL nChangeData  AS LONG  ' for RMC_SetData() demonstration in the first line chart
GLOBAL nShowClone   AS LONG  ' for show/hide the cloned chart in MiniDesigner()
GLOBAL aCurColors() AS LONG  ' for UI in MiniDesigner()
GLOBAL aTimerData() AS DOUBLE ' for TimerChart
GLOBAL nIsChart2    AS LONG   ' is second chart existing?
GLOBAL hCursorWait  AS LONG

TYPE OPENFILENAME
   lStructSize       AS DWORD
   hWndOwner         AS DWORD
   hInstance         AS DWORD
   lpstrFilter       AS ASCIIZ PTR
   lpstrCustomFilter AS ASCIIZ PTR
   nMaxCustFilter    AS DWORD
   nFilterIndex      AS DWORD
   lpstrFile         AS ASCIIZ PTR
   nMaxFile          AS DWORD
   lpstrFileTitle    AS ASCIIZ PTR
   nMaxFileTitle     AS DWORD
   lpstrInitialDir   AS ASCIIZ PTR
   lpstrTitle        AS ASCIIZ PTR
   Flags             AS DWORD
   nFileOffset       AS WORD
   nFileExtension    AS WORD
   lpstrDefExt       AS ASCIIZ PTR
   lCustData         AS LONG
   lpfnHook          AS DWORD
   lpTemplateName    AS ASCIIZ PTR
END TYPE
%MAX_PATH  = 260
%OFN_PATHMUSTEXIST = &H00000800
%OFN_FILEMUSTEXIST = &H00001000
DECLARE FUNCTION GETSAVEFILENAME LIB"COMDLG32.DLL" ALIAS"GetSaveFileNameA"(lpofn AS OPENFILENAME) AS LONG
 
FUNCTION SaveFileDialog (BYVAL hWnd AS DWORD, _           
                         BYVAL sCaption AS STRING, _      
                         sFileSpec AS STRING, _           
                         BYVAL sInitialDir AS STRING, _   
                         BYVAL sFilter AS STRING, _       
                         BYVAL sDefExtension AS STRING, _ 
                         dFlags AS DWORD _                
                         ) AS LONG
    LOCAL ix          AS LONG
    LOCAL ofn         AS OPENFILENAME
    LOCAL szFileTitle AS ASCIIZ * %MAX_PATH
    ' Filter is a sequence of ASCIIZ strings with a final (extra) $NUL terminator
    REPLACE "|" WITH $NUL IN sFilter
    sFilter = sFilter + $NUL
    IF LEN(sInitialDir) = 0 THEN
        sInitialDir = CURDIR$
    END IF
    IF LEN(sFileSpec) > %MAX_PATH THEN
        sFileSpec = LEFT$(sFileSpec, %MAX_PATH)
    END IF
    ix = INSTR(sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix) + SPACE$(%MAX_PATH - ix)
    ELSE
        sFileSpec = sFileSpec + $NUL + SPACE$(%MAX_PATH - LEN(sFileSpec))
    END IF
    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = STRPTR(sFilter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = STRPTR(sFileSpec)
    ofn.nMaxFile         = LEN(sFileSpec)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = STRPTR(sInitialDir)
    IF LEN(sCaption) THEN
        ofn.lpstrTitle   = STRPTR(sCaption)
    END IF
    ofn.Flags            = dFlags
    IF LEN(sDefExtension) THEN
        ofn.lpstrDefExt  = STRPTR(sDefExtension)
    END IF
    FUNCTION = GETSAVEFILENAME(ofn)
    ix = INSTR(sFileSpec, $NUL)
    IF ix THEN
        sFileSpec = LEFT$(sFileSpec, ix - 1)
    ELSE
        sFileSpec = ""
    END IF
    dFlags = ofn.Flags
END FUNCTION
 
SUB ExportTheChart(BYVAL hDlg AS LONG, BYVAL nCtrlID AS LONG)
    LOCAL sFilter AS STRING
    LOCAL nFlags AS LONG
    LOCAL sFileName AS STRING
    LOCAL szFileName AS ASCIIZ * 200
    LOCAL nResult AS LONG
 
    nFlags = %OFN_FILEMUSTEXIST OR %OFN_PATHMUSTEXIST
 
    sFilter = "Graphic Files (*.jpg*.png)" & CHR$(0) & "*.png;*.jpg;*.jpeg;" & CHR$(0) & _
              "ALL Files (*.*)" & CHR$(0) & _
              "*.*" & CHR$(0) & CHR$(0)
    nResult = SAVEFILEDIALOG (hDlg,"EXPORT Chart",sFileName,"", sFilter, "png",nFlags)
    IF nResult <> 0 THEN
        szFilename = sFileName
        RMC_Draw2File nCtrlID, szFileName
    END IF
END SUB
 
TYPE PRINTDLGAPI
    lStructSize              AS DWORD
    hWndOwner                AS DWORD
    hDevMode                 AS DWORD
    hDevNames                AS DWORD
    hDC                      AS DWORD
    Flags                    AS DWORD
    nFromPage                AS WORD
    nToPage                  AS WORD
    nMinPage                 AS WORD
    nMaxPage                 AS WORD
    nCopies                  AS WORD
    hInstance                AS DWORD
    lCustData                AS LONG
    lpfnPrintHook            AS DWORD
    lpfnSetupHook            AS DWORD
    lpPrintTemplateName      AS ASCIIZ PTR
    lpPrintSetupTemplateName AS ASCIIZ PTR
    hPrintTemplate           AS DWORD
    hSetupTemplate           AS DWORD
END TYPE
 
%PD_RETURNDC   = &H00000100
%PD_SHOWHELP   = &H00000800
DECLARE FUNCTION PRINTDLG LIB "COMDLG32.DLL" ALIAS "PrintDlgA" (lpPd AS PRINTDLGAPI) AS LONG
 
FUNCTION PrinterDialog1 (BYVAL hWnd AS DWORD, _      
                         Flags AS DWORD, _           
                         hDC AS DWORD, _             
                         nCopies AS WORD, _          
                         nFromPage AS WORD, _        
                         nToPage AS WORD, _          
                         BYVAL nMinPage AS WORD, _   
                         BYVAL nMaxPage AS WORD _    
                         ) AS LONG
    LOCAL pd AS PRINTDLGAPI
    LOCAL save_hDevMode  AS LONG
    LOCAL save_hDevNames  AS LONG
 
    pd.lStructSize = SIZEOF(pd)
    pd.hDevMode    = save_hDevMode
    pd.hDevNames   = save_hDevNames
    pd.hWndOwner   = hWnd
    pd.Flags       = Flags OR %PD_SHOWHELP OR %PD_RETURNDC
    pd.nCopies     = nCopies
    pd.nFromPage   = MAX(nFromPage, nMinPage)
    pd.nToPage     = MAX(MIN(nToPage, nMaxPage), nMaxPage)
    pd.nMinPage    = nMinPage
    pd.nMaxPage    = nMaxPage
    IF PRINTDLG(pd) THEN
        hDC            = pd.hDC
        FUNCTION = %TRUE
    END IF
END FUNCTION


SUB ShowInfo(TINFO AS tRMC_INFO)
    ' Is called from the Callback DlgCallback() every time you click with the left mousebutton onto the chart
    LOCAL sInfo AS STRING
    
    sInfo = sInfo + "Info about the mousepointer:"+$CRLF
    sInfo = sInfo + "------------------------------"+$CRLF
    sInfo = sInfo + "X position: "+$TAB+STR$(TINFO.nXPos)+$CRLF _
                  + "Y position: "+$TAB+STR$(TINFO.nYPos)
    IF TINFO.nRegionIndex > 0 THEN
        sInfo = sInfo + $CRLF + $CRLF + "Info about the region:"+$CRLF
        sInfo = sInfo + "------------------------------"+$CRLF
        sInfo = sInfo + "Regionindex:"+$TAB+STR$(TINFO.nRegionIndex)+$CRLF _
                      + "Left position:" +$TAB+STR$(TINFO.nRLeft)+$CRLF _ 
                      + "Top position:"+$TAB+STR$(TINFO.nRTop)+$CRLF _ 
                      + "Right position:"+$TAB+STR$(TINFO.nRRight)+$CRLF _ 
                      + "Bottom position:"+$TAB+STR$(TINFO.nRBottom)
    END IF
    IF TINFO.nRegionIndex < 0 THEN ' Special case: this is a CustomObject
        sInfo = sInfo + $CRLF + $CRLF + "Info about the CustomObject:"+$CRLF
        sInfo = sInfo + "------------------------------"+$CRLF
        sInfo = sInfo + "Index:"+$TAB+$TAB+STR$(ABS(TINFO.nRegionIndex))+$CRLF _
                      + "Type:" +$TAB+$TAB+CHOOSE$(TINFO.nChartType,"Text","Box","Circle","Line","Image","Symbol","Polygon")+$CRLF _
                      + "Left position:" +$TAB+STR$(TINFO.nRLeft)+$CRLF _
                      + "Top position:"+$TAB+STR$(TINFO.nRTop)+$CRLF _
                      + "Right position:"+$TAB+STR$(TINFO.nRRight)+$CRLF _
                      + "Bottom position:"+$TAB+STR$(TINFO.nRBottom)

    END IF    
    IF TINFO.nGLeft + TINFO.nGRight > 0 THEN
        sInfo = sInfo + $CRLF + $CRLF + "Info about the grid:"+$CRLF
        sInfo = sInfo + "------------------------------"+$CRLF
        sInfo = sInfo + "Left position:" +$TAB+STR$(TINFO.nGLeft)+$CRLF _ 
                      + "Top position:"+$TAB+STR$(TINFO.nGTop)+$CRLF _ 
                      + "Right position:"+$TAB+STR$(TINFO.nGRight)+$CRLF _ 
                      + "Bottom position:"+$TAB+STR$(TINFO.nGBottom)+$CRLF
        IF TINFO.nGCol > 0 THEN
            SELECT CASE TINFO.nChartType
                CASE %RMC_BARSINGLE TO %RMC_HIGHLOW
                    sInfo = sInfo + "Column:" +$TAB+$TAB+STR$(TINFO.nGCol)+$CRLF _
                                  + "Row:" +$TAB+$TAB+STR$(TINFO.nGRow)
                CASE %RMC_XYCHART
                    sInfo = sInfo + "Sector-index of 1. axes pair:" +$TAB+STR$(TINFO.nGCol)
                    IF TINFO.nGRow > 0 THEN
                        sInfo = sInfo + $CRLF+"Sector-index of 2. axes pair:" +$TAB+STR$(TINFO.nGRow)
                    END IF
            END SELECT
        END IF
    END IF
    IF TINFO.nSeriesIndex > 0 THEN
        sInfo = sInfo + $CRLF + $CRLF + "Info about the series:"+$CRLF
        sInfo = sInfo + "------------------------------"+$CRLF
        sInfo = sInfo + "Seriesindex:" +$TAB+STR$(TINFO.nSeriesIndex)+$CRLF
        sInfo = sInfo + "Dataindex:" +$TAB+STR$(TINFO.nDataIndex)+$CRLF
        IF TINFO.nChartType = %RMC_GRIDLESS THEN
        ELSE
            sInfo = sInfo + "Left position:" +$TAB+STR$(TINFO.nSLeft)+$CRLF _ 
                          + "Top position:"+$TAB+STR$(TINFO.nSTop)+$CRLF _ 
                          + "Right position:"+$TAB+STR$(TINFO.nSRight)+$CRLF _ 
                          + "Bottom position:"+$TAB+STR$(TINFO.nSBottom)+$CRLF
            IF TINFO.nChartType = %RMC_HIGHLOW THEN
                sInfo = sInfo + "Y-pos. Open point:" +$TAB+STR$(TINFO.nSTop2)+$CRLF _ 
                              + "Y-pos. Close point:"+$TAB+STR$(TINFO.nSBottom2)+$CRLF
            END IF
        END IF
        SELECT CASE TINFO.nChartType
            CASE %RMC_BARSINGLE,%RMC_BARGROUP,%RMC_LINE,%RMC_AREA,%RMC_VOLUMEBAR,%RMC_AREA_STACKED
                sInfo = sInfo + "Data value:" +$TAB+FORMAT$(TINFO.nData1,"0.00")+$CRLF
            CASE %RMC_FLOATINGBAR,%RMC_FLOATINGBARGROUP
                sInfo = sInfo + "Starting data:" +$TAB+FORMAT$(TINFO.nData1,"0.00")+$CRLF
                sInfo = sInfo + "Length data:" +$TAB+FORMAT$(TINFO.nData2,"0.00")+$CRLF
            CASE %RMC_BARSTACKED,%RMC_BARSTACKED100,%RMC_LINE_INDEXED,%RMC_AREA_INDEXED,%RMC_GRIDLESS,%RMC_AREA_STACKED100
                sInfo = sInfo + "Absolut data value:" +$TAB+FORMAT$(TINFO.nData1,"0.00")+$CRLF
                sInfo = sInfo + "Percent data value:" +$TAB+FORMAT$(TINFO.nData2,"0.00")+$CRLF
            CASE %RMC_XYCHART
                sInfo = sInfo + "X-data value:" +$TAB+FORMAT$(TINFO.nData1,"0.00")+$CRLF
                sInfo = sInfo + "Y-data value:" +$TAB+FORMAT$(TINFO.nData2,"0.00")+$CRLF
            CASE %RMC_HIGHLOW
                sInfo = sInfo + "Open data:" +$TAB+FORMAT$(TINFO.nData1,"0.00")+$CRLF
                sInfo = sInfo + "High data:" +$TAB+FORMAT$(TINFO.nData2,"0.00")+$CRLF
                sInfo = sInfo + "Low data:" +$TAB+FORMAT$(TINFO.nData3,"0.00")+$CRLF
                sInfo = sInfo + "Close data:" +$TAB+FORMAT$(TINFO.nData4,"0.00")+$CRLF
        END SELECT
    END IF
    IF TINFO.nGLeft + TINFO.nGRight > 0 THEN
        sInfo = sInfo + $CRLF + $CRLF + "Data value, which is correspondent"+$CRLF _
                                      +  "to this X/Y location:"+$CRLF
        sInfo = sInfo + "------------------------------"+$CRLF
        IF TINFO.nChartType = %RMC_XYCHART THEN
            sInfo = sInfo + "X-data value of 1. axes pair: " +$TAB+FORMAT$(TINFO.nVirtData1,"0.00")+$CRLF
            sInfo = sInfo + "Y-data value of 1. axes pair: " +$TAB+FORMAT$(TINFO.nVirtData2,"0.00")+$CRLF
            IF TINFO.nVirtData3 <> 0 AND TINFO.nVirtData4 <> 0 THEN
                sInfo = sInfo + "X-data value of 2. axes pair: " +$TAB+FORMAT$(TINFO.nVirtData3,"0.00")+$CRLF
                sInfo = sInfo + "Y-data value of 2. axes pair: " +$TAB+FORMAT$(TINFO.nVirtData4,"0.00")+$CRLF
            END IF
        ELSE
            sInfo = sInfo + "Data value of the 1. data-axis:" +$TAB+FORMAT$(TINFO.nVirtData1,"0.00")+$CRLF
            IF TINFO.nVirtData2 <> 0 THEN
                sInfo = sInfo + "Data value of the 2. data-axis:" +$TAB+FORMAT$(TINFO.nVirtData2,"0.00")+$CRLF
            END IF
        END IF
    END IF
    MSGBOX sInfo,%MB_OK OR %MB_ICONINFORMATION,"RMChart Demo"  
END SUB



''''''' Grid Based ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
FUNCTION Show_Bars(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE



    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,0,0,0,"","")        ' create the chart control
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"")                                   ' add a Region to the chart
    nRetval = RMC_AddCaption(%ID_RMC1,1,"This is the chart's caption",%ColorBlue,%ColorYellow,11,%TRUE)  ' add a Caption to region 1
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorBeige,0,0,0,0,0,%RMC_BICOLOR_LABELAXIS) ' add a Grid to region 1
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,100,11) ' add a Data axis to region 1
    nRetval = RMC_AddLabelAxis(%ID_RMC1,1, "Label 1*Label 2*Label 3*Label 4*Label 5",1,0,0,0,0,0,0,0,"")' add a Label axis to region 1
              RMC_SetLAXLineStyle %ID_RMC1,1,%RMC_LINESTYLENONE ' No lines for the label axis
    sTemp = "60*70*40*80*30"
    nC = RMC_Split2Double(sTemp, aData())                               ' read data values into array
    nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),nC,%RMC_BARSINGLE,%RMC_BAR_FLAT_GRADIENT1) ' add a Bar series to region 1
                                                                        ' all bars have as default the same color, but:
    nRetval = RMC_SetSeriesColor(%ID_RMC1,1,1,%ColorRed,3)              ' bar #3 gets Red


    ' Now add an average line:
    LOCAL nAverage#,nL&,nT&,nR&,nB&
    REDIM aXPoints(2) AS LONG
    REDIM aYPoints(2) AS LONG
    
    ' Calc the average and get the needed X/Y positions (nL,nT,nR,nB) for the line
    RMC_CalcAverage %ID_RMC1,1,1,nAverage,nL,nT,nR,nB                                           
    
    ' Add a CustomLine to show the average:
    RMC_CODash %ID_RMC1,1,nL,nT,nR,nB,%RMC_LINE_FLAT,%ColorGreen,0,2
    
    ' Draw the "legend" for the average line:
    RMC_Split2Long "480*565*565",aXPoints()  ' X-Position
    RMC_Split2Long "175*175*208",aYPoints()  ' Y-Position
    ' OR:
    'aXPoints(0) = 480 : aXPoints(1) = 565 : aXPoints(2) = 565
    'aYPoints(0) = 175 : aYPoints(1) = 175 : aYPoints(2) = 208
    RMC_COLine %ID_RMC1,2,aXPoints(0),aYPoints(0),3,%RMC_LINE_FLAT,%ColorGreen,0,2,0,%RMC_ANCHOR_ARROW_OPEN
    RMC_COText %ID_RMC1,3," Average (" + FORMAT$(nAverage,"0.00") + ")",480,159


    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart 
END FUNCTION

FUNCTION Show_BarsImage(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    
    nChangeData = %FALSE  ' disallow data change when left mousebutton is clicked

    LOCAL nToolTipWidth AS LONG
    nToolTipWidth = 100 ' We want to have ToolTips, so we must set the width. To avoid them, set it to zero
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorTransparent, _
                              %RMC_CTRLSTYLEIMAGE,%FALSE,"seasky.jpg","",nToolTipWidth) 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add grid to region 1 ***************************** 
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorTransparent,%FALSE,0,0,0,0) 
    '************** Add data axis to region 1 ***************************** 
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,100,11,8,%ColorChalk,%ColorChalk,%RMC_LINESTYLEDOT,0,"","") 
    '************** Add label axis to region 1 ***************************** 
    nRetval = RMC_AddLabelAxis(%ID_RMC1,1, "Label 1*Label 2*Label 3*Label 4*Label 5",1,5, _
                               %RMC_LABELAXISBOTTOM,8,%ColorYellow,%RMC_TEXTCENTER,%ColorChalk,%RMC_LINESTYLENONE,"") 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData(4)
    aData(0) = 50 : aData(1) = 70 : aData(2) = 40 : aData(3) = 60 : aData(4) = 30
    nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),5,%RMC_BARSINGLE,%RMC_BAR_FLAT_GRADIENT2, _
                               %TRUE,%ColorTransparent,%FALSE,1,%FALSE,1,%RMC_HATCHBRUSH_OFF) 
    ' -------------------------------^^^^^^^^^^^^^^^^
    ' -------------------------------This forces different
    '                                colors for the bars
    

    ' Let's set some CustomToolTipTexts:
    RMC_SetCustomToolTipText %ID_RMC1,1,1,1,"First Bar"+$CRLF+"Value: 50"+$CRLF+"Color: Blue"
    RMC_SetCustomToolTipText %ID_RMC1,1,1,2,"Second Bar"+$CRLF+"Value: 70"+$CRLF+"Color: Green"
    RMC_SetCustomToolTipText %ID_RMC1,1,1,3,"Third Bar"+$CRLF+"Value: 40"+$CRLF+"Color: Red"
    RMC_SetCustomToolTipText %ID_RMC1,1,1,4,"Fourth Bar"+$CRLF+"Value: 60"+$CRLF+"Color: Yellow"
    ' Last bar gets no CustomText, so the default ToolTipText (=Value) is used
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?    

    RMC_Draw %ID_RMC1

END FUNCTION



FUNCTION Show_GroupedBars(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    LOCAL szTemp AS ASCIIZ * 500
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    LOCAL tChart AS tRMC_CHART
    LOCAL tRegion AS tRMC_REGION
    LOCAL tCaption AS tRMC_CAPTION
    LOCAL tLegend AS tRMC_LEGEND
    LOCAL tGrid AS tRMC_GRID
    LOCAL tDataAxis AS tRMC_DATAAXIS
    LOCAL tLabelAxis AS tRMC_LABELAXIS
    LOCAL tBarSeries AS tRMC_BARSERIES
 
    ' This example uses the alternative long notation style (with UDTs) and omits
    ' no property: the code is bigger, but it's easier to change
    ' properties for testing purposes
 
    '************** Create the chart ********************** 
    tChart.nLeft        = 10  
    tChart.nTop         = 10  
    tChart.nWidth       = 600
    tChart.nHeight      = 450
    tChart.nBackColor   = %ColorDefault
    tChart.nCtrlStyle   = %RMC_CTRLSTYLEFLAT
    tChart.nToolTipWidth=200 ' We want ToolTips, so set the width
    nRetVal = RMC_CreateChartI(hParentDlg, %ID_RMC1, tChart)
    '************** Add Region 1 ***************************** 
    tRegion.nLeft       = 5
    tRegion.nTop        = 5
    tRegion.nWidth      = -5
    tRegion.nHeight     = -5
    tRegion.sFooter     = ""
    tRegion.nShowBorder = %FALSE
    nRetval = RMC_AddRegionI(%ID_RMC1, tRegion) 
    '************** Add grid to region 1 ***************************** 
    tGrid.nGridBackColor = %ColorDefault
    tGrid.nAsGradient    = %FALSE
    tGrid.nLeft      = 0
    tGrid.nTop       = 0
    tGrid.nWidth     = 0
    tGrid.nHeight    = 0
    nRetval = RMC_AddGridI(%ID_RMC1, 1, tGrid)
    '************** Add data axis to region 1 ***************************** 
    tDataAxis.nAlignment      = %RMC_DATAAXISLEFT
    tDataAxis.nMinValue       = 0
    tDataAxis.nMaxValue       = 100
    tDataAxis.nTickCount      = 11
    tDataAxis.nFontsize       = 8
    tDataAxis.nTextColor      = %ColorDefault
    tDataAxis.nLineColor      = %ColorDefault
    tDataAxis.nLineStyle      = %RMC_LINESTYLESOLID
    tDataAxis.nDecimalDigits  = 0
    tDataAxis.sUnit           = ""
    tDataAxis.sText           = ""
    nRetval = RMC_AddDataAxisI(%ID_RMC1, 1, tDataAxis)
    '************** Add label axis to region 1 ***************************** 
    tLabelAxis.nCount         = 1
    tLabelAxis.nTickCount     = 5
    tLabelAxis.nAlignment     = %RMC_LABELAXISBOTTOM
    tLabelAxis.nFontsize      = 8
    tLabelAxis.nTextColor     = %ColorDefault
    tLabelAxis.nTextAlignment = %RMC_TEXTCENTER
    tLabelAxis.nLineColor     = %ColorDefault
    tLabelAxis.nLineStyle     = %RMC_LINESTYLESOLID
    szTemp = "2000*2001*2002*2003*2004"
    nRetval = RMC_AddLabelAxisI(%ID_RMC1, 1, szTemp, tLabelAxis)
    '************** Add legend to region 1 ******************************* 
    tLegend.nLegendAlign    = %RMC_LEGEND_TOP
    tLegend.nLegendBackColor= %ColorDefault
    tLegend.nLegendStyle    = %RMC_LEGENDRECT
    tLegend.nLegendTextColor= %ColorDefault
    tLegend.nLegendFontSize = 8
    tLegend.nLegendIsBold   = %FALSE
    szTemp = "First quarter*Second quarter*Third quarter*Fourth quarter"
    nRetval = RMC_AddLegendI(%ID_RMC1, 1, szTemp, tLegend)    
    '************** Add Series 1 to region 1 ******************************* 
    tBarSeries.nType             = %RMC_BARGROUP
    tBarSeries.nStyle            = %RMC_BAR_HOVER
    tBarSeries.nIsLucent         = %FALSE
    tBarSeries.nColor            = %ColorDefault
    tBarSeries.nIsHorizontal     = %FALSE
    tBarSeries.nWhichDataAxis    = 1
    tBarSeries.nValueLabelOn     = %FALSE
    tBarSeries.nPointsPerColumn  = 1
    tBarSeries.nHatchMode        = %RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    sTemp = "30*20*40*60*10"
    nC = RMC_Split2Double(sTemp, aData())
    nRetval = RMC_AddBarSeriesI(%ID_RMC1, 1, aData(0),nC, tBarSeries)
    '************** Add Series 2 to region 1 ******************************* 
    tBarSeries.nType             = %RMC_BARGROUP
    tBarSeries.nStyle            = %RMC_BAR_HOVER
    tBarSeries.nIsLucent         = %FALSE
    tBarSeries.nColor            = %ColorDefault
    tBarSeries.nIsHorizontal     = %FALSE
    tBarSeries.nWhichDataAxis    = 1
    tBarSeries.nValueLabelOn     = %FALSE
    tBarSeries.nPointsPerColumn  = 1
    tBarSeries.nHatchMode        = %RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    sTemp = "30*20*50*70*60"
    nC = RMC_Split2Double(sTemp, aData())
    nRetval = RMC_AddBarSeriesI(%ID_RMC1, 1, aData(0),nC, tBarSeries)
    '************** Add Series 3 to region 1 ******************************* 
    tBarSeries.nType             = %RMC_BARGROUP
    tBarSeries.nStyle            = %RMC_BAR_HOVER
    tBarSeries.nIsLucent         = %FALSE
    tBarSeries.nColor            = %ColorDefault
    tBarSeries.nIsHorizontal     = %FALSE
    tBarSeries.nWhichDataAxis    = 1
    tBarSeries.nValueLabelOn     = %FALSE
    tBarSeries.nPointsPerColumn  = 1
    tBarSeries.nHatchMode        = %RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    sTemp = "40*10*30*20*80"
    nC = RMC_Split2Double(sTemp, aData())
    nRetval = RMC_AddBarSeriesI(%ID_RMC1, 1, aData(0),nC, tBarSeries)
    '************** Add Series 4 to region 1 ******************************* 
    tBarSeries.nType             = %RMC_BARGROUP
    tBarSeries.nStyle            = %RMC_BAR_HOVER
    tBarSeries.nIsLucent         = %FALSE
    tBarSeries.nColor            = %ColorDefault
    tBarSeries.nIsHorizontal     = %FALSE
    tBarSeries.nWhichDataAxis    = 1
    tBarSeries.nValueLabelOn     = %FALSE
    tBarSeries.nPointsPerColumn  = 1
    tBarSeries.nHatchMode        = %RMC_HATCHBRUSH_OFF
    '****** Read data values ******
    sTemp = "70*50*80*40*30"
    nC = RMC_Split2Double(sTemp, aData())
    nRetval = RMC_AddBarSeriesI(%ID_RMC1, 1, aData(0),nC, tBarSeries)
 
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart 
END FUNCTION

FUNCTION Show_StackedBars(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
 
    
    LOCAL nToolTipWidth AS LONG
    nToolTipWidth = 100 ' We want to have ToolTips, so we must set the width. To avoid them, set it to zero
    
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorBisque,%RMC_CTRLSTYLE3DLIGHT,0,"","",nToolTipWidth) 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,10,-5,-5,"this is the footer",%FALSE) 
    '************** Add caption to region 1 ******************* 
    nRetval = RMC_AddCaption(%ID_RMC1,1,"Example of stacked bars",%ColorBisque,%ColorBlack,11,%TRUE) 
    '************** Add grid to region 1 ***************************** 
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorCornsilk,%FALSE,0,0,0,0) 
    '************** Add data axis to region 1 ***************************** 
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISBOTTOM,0,50000,11,8,%ColorBlack,%ColorBlack,%RMC_LINESTYLESOLID,0,"$","This is an optional axis text") 
    '************** Add label axis to region 1 ***************************** 
    nRetval = RMC_AddLabelAxis(%ID_RMC1,1, "Label Nr. 1*Label Nr. 2*Label Nr. 3*Label Nr. 4*Label Nr. 5*Label Nr. 6",1,6,0,0,0,0,0,0,"")
    '************** Add legend to region 1 ******************************* 
    nRetval = RMC_AddLegend(%ID_RMC1,1,"Apples*Pears*Cherries*Strawberries",%RMC_LEGEND_CUSTOM_UR,%ColorLightYellow,%RMC_LEGENDRECT,%ColorBlue)
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_Split2Double("10000*10000*16000*12000*20000*10000", aData())
     nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),nC,%RMC_BARSTACKED,%RMC_COLUMN_FLAT,%FALSE,%ColorDarkBlue,%TRUE)
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_Split2Double("5000*7000*4000*15000*10000*10000", aData())
     nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),nC,%RMC_BARSTACKED,%RMC_COLUMN_FLAT,%FALSE,%ColorDarkGreen,%TRUE)
    '************** Add Series 3 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_Split2Double("10000*3000*12000*10000*5000*20000", aData())
     nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),nC,%RMC_BARSTACKED,%RMC_COLUMN_FLAT,%FALSE,%ColorMaroon,%TRUE)
    '************** Add Series 4 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_Split2Double("5000*9000*12000*6000*10000*5000", aData())
    nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),nC,%RMC_BARSTACKED,%RMC_COLUMN_FLAT,%FALSE,%ColorDarkGoldenrod,%TRUE)
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION

FUNCTION Show_FloatingBars(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetVal AS LONG
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
 
 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,550,300,%ColorLightGray,%RMC_CTRLSTYLE3DLIGHT,%FALSE,"","Tahoma")
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    nRetVal = RMC_AddCaption(%ID_RMC1,1,"Birth of a Killer App",%ColorDefault,%ColorBlack,11,%TRUE) 
    nRetVal = RMC_AddGrid(%ID_RMC1,1,%ColorPaleGoldenrod,%TRUE,0,0,0,0,%RMC_BICOLOR_NONE) 
    ' the string labels for the data axis:
    szTemp = "04/01*04/02*04/03*04/04*04/05*04/06*04/07*04/08*04/09*04/10*04/11*04/12*05/01"
    nRetVal = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISBOTTOM,1,13,13,8,%ColorBlack,%ColorBlack,%RMC_LINESTYLESOLID,0,"","",szTemp,%RMC_TEXTCENTER) 
    ' the labels for the label axis:
    szTemp = "Design*Development*Testing*Bug Fixing*Documentation*Marketing"
    nRetVal = RMC_AddLabelAxis(%ID_RMC1,1, szTemp,1,6,%RMC_LABELAXISLEFT,8,%ColorBlack,%RMC_TEXTCENTER,%ColorBlack,%RMC_LINESTYLESOLID,"") 
    ' the legend:
    szTemp = "Schedule*Reality"
    nRetVal = RMC_AddLegend(%ID_RMC1,1,szTemp,%RMC_LEGEND_CUSTOM_UR,%ColorLightBlue,%RMC_LEGENDRECT,%ColorMediumBlue,8,%FALSE) 
    ' data for the first series, each bar has two data points, the start value and the length value:
    REDIM aData(11)
    aData(0) = 1 : aData(1) = 3  ' first bar starts at 1 and has a length of 3
    aData(2) = 4 : aData(3) = 6  ' second bar starts at 4 and has a length of 6
    aData(4) = 6 : aData(5) = 4 
    aData(6) = 7 : aData(7) = 4 
    aData(8) = 9 : aData(9) = 3
    aData(10) = 10 : aData(11) = 3
    nRetVal = RMC_AddBarSeries(%ID_RMC1,1,aData(0), 12,%RMC_FLOATINGBARGROUP,%RMC_BAR_HOVER,%FALSE,%ColorPaleGreen,%TRUE,1,%RMC_VLABEL_NONE,1,%RMC_HATCHBRUSH_OFF) 
    ' data for the second series, each bar has two data points, the start value and the length value:
    REDIM aData(11)
    aData(0) = 1 : aData(1) = .5 : aData(2) = 1.5 : aData(3) = 10.5 : aData(4) = 12
    aData(5) = 1 : aData(6) = 12 : aData(7) = 1 : aData(8) = 12.5 : aData(9) = .5
    aData(10) = 2 : aData(11) = 11
    nRetVal = RMC_AddBarSeries(%ID_RMC1,1,aData(0), 12,%RMC_FLOATINGBARGROUP,%RMC_BAR_HOVER,%FALSE,%ColorOrangeRed,%TRUE,1,%RMC_VLABEL_NONE,2,%RMC_HATCHBRUSH_OFF) 
    nRetVal = RMC_Draw(%ID_RMC1)
    IF nRetVal < 0 THEN GOTO IsError
    EXIT FUNCTION
 
    IsError: 
END FUNCTION


FUNCTION Show_Line(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aPPC(0) AS LONG
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,0,0,0,"","") 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"Click with the left mousebutton into the grid!\C11") 
    '************** Add caption to region 1 ******************* 
    nRetval = RMC_AddCaption(%ID_RMC1,1,"Simple line",%ColorAquamarine,%ColorBlack,10,%TRUE) 
    '************** Add grid to region 1 ***************************** 
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorBeige) 
    '************** Add data axis to region 1 ***************************** 
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,100,11) 
    '************** Add label axis to region 1 ***************************** 
    nRetval = RMC_AddLabelAxis(%ID_RMC1,1, "",1,20,0,0,0,0,0,0,"") 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    sTemp = "15*25*30*22*75*45*65*75*40*35*20*45*80*90*70*65*25*10*30*20"
    nC = RMC_Split2Double(sTemp, aData())
    nRetval = RMC_AddLineSeries(%ID_RMC1,1, aData(0),nC, 0,0,%RMC_LINE,%RMC_LINE_FLAT,%RMC_LSTYLE_LINE_AREA,%FALSE, _
                                %ColorDefault,%RMC_SYMBOL_POINT,1,%TRUE,%RMC_HATCHBRUSH_OFF) 
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    ' Now add a trend line:
    LOCAL nFirst#,nLast#,nL&,nT&,nR&,nB&

    ' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
    RMC_CalcTrend %ID_RMC1,1,1,nFirst,nLast,nL,nT,nR,nB                                           

    ' Add a CustomLine to show the trend:
    RMC_CODash %ID_RMC1,1,nL,nT,nR,nB,%RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,%ColorRed,%ColorGreen),0,2,0,%RMC_ANCHOR_ARROW_CLOSED
    
    ' Draw the "legend" for the trend line:
    RMC_CODash %ID_RMC1,2,470,11,500,11,%RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,%ColorRed,%ColorGreen),0,2
    RMC_COText %ID_RMC1,3,"Trend",505,5


    ' Draw the chart
    RMC_Draw %ID_RMC1

END FUNCTION   



FUNCTION Show_3Lines(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aPPC(0) AS LONG

    ' This one reads the data from *.csv-files:

    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorPaleGreen,%RMC_CTRLSTYLEFLATSHADOW,0,"","") 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,10,-5,-5,"data on a weekly basis. source: www.yahoo.com",%FALSE) 
    '************** Add caption to region 1 ******************* 
    nRetval = RMC_AddCaption(%ID_RMC1,1,"Performance of DOW JONES, DAX and NASDAQ from January 2000 to end of June 2004",%ColorPaleGreen,%ColorDarkBlue,9,%TRUE) 
    '************** Add grid to region 1 ***************************** 
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorLightBlue,%TRUE,0,0,0,0) 
    '************** Add data axis to region 1 ***************************** 
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,0,11,8,%ColorDarkBlue,%ColorDarkSlateGray,%RMC_LINESTYLEDOT,%TRUE,"%","2nd January 2000 = 100%") 
    '************** Add label axis to region 1 ***************************** 
    nRetval = RMC_AddLabelAxis(%ID_RMC1,1, "2000*2001*2002*2003*2004",1,5,%RMC_LABELAXISBOTTOM,8,%ColorDarkBlue,%RMC_TEXTCENTER,%ColorDarkSlateGray,%RMC_LINESTYLEDOT,"") 
    '************** Add legend to region 1 ******************************* 
    nRetval = RMC_AddLegend(%ID_RMC1,1,"DOW JONES*DAX*NASDAQ",%RMC_LEGEND_CUSTOM_UR,%ColorPaleTurquoise,%RMC_LEGENDRECT,%ColorDarkBlue,8,%FALSE) 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read points per column ******
    aPPC(0) = 52
    '****** Read data values ******
    nC = RMC_ReadDataFromFile(aData(),"dow00-04.csv","234,1","5",",")
    nRetval = RMC_AddLineSeries(%ID_RMC1,1, aData(0),nC, aPPC(0),1,%RMC_LINE_INDEXED,%RMC_LINE_FLAT,%RMC_LSTYLE_LINE,%FALSE, _
                                %ColorBlue,%RMC_SYMBOL_NONE,1,%FALSE,%RMC_HATCHBRUSH_OFF) 
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_ReadDataFromFile(aData(),"dax00-04.csv","235,1","5",",")
    nRetval = RMC_AddLineSeries(%ID_RMC1,1, aData(0),nC, aPPC(0),1,%RMC_LINE_INDEXED,%RMC_LINE_FLAT,%RMC_LSTYLE_LINE,%FALSE, _
                                %ColorCrimson,%RMC_SYMBOL_NONE,1,%FALSE,%RMC_HATCHBRUSH_OFF) 
    '************** Add Series 3 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_ReadDataFromFile(aData(),"nasdaq00-04.csv","234,1","5",",")
    nRetval = RMC_AddLineSeries(%ID_RMC1,1, aData(0),nC, aPPC(0),1,%RMC_LINE_INDEXED,%RMC_LINE_FLAT,%RMC_LSTYLE_LINE,%FALSE, _
                                %ColorBlack,%RMC_SYMBOL_NONE,1,%FALSE,%RMC_HATCHBRUSH_OFF) 

    ' Add some CustomObjects
    RMC_COText %ID_RMC1,1,"09/11/2001",287,117,80,22,0,%ColorLightGreen,0,150,0,0,"CB"
    RMC_CODash %ID_RMC1,2,327,141,256,243,0,%ColorLightGreen,0,2,0,%RMC_ANCHOR_ARROW_OPEN
    RMC_CODash %ID_RMC1,3,327,141,256,294,0,%ColorLightGreen,0,2,0,%RMC_ANCHOR_ARROW_OPEN
    RMC_CODash %ID_RMC1,4,327,141,256,352,0,%ColorLightGreen,0,2,0,%RMC_ANCHOR_ARROW_OPEN
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION    


SUB AddMoveAverage(aData() AS DOUBLE, BYVAL nPeriod AS LONG, BYVAL nColor AS LONG)
    REGISTER i&,x&
    LOCAL nCount&,nRetval&,y&,z&
    LOCAL aData1() AS DOUBLE
    LOCAL tLineSeries AS tRMC_LINESERIES
    REDIM aPPC(0) AS LONG


    nCount = UBOUND(aData())+1
    REDIM aData1(1 TO nCount)

    FOR i = 1 TO nCount
        IF i < nPeriod THEN            ' If no data available for building the average
            aData1(i) = %RMC_NO_DATA   ' add the "NoData" Symbol
        ELSE
            y = (i-nPeriod) : z = i-1
            FOR x = y TO z
                aData1(i) = aData1(i)+aData(x)
            NEXT
            aData1(i) = aData1(i) / nPeriod
        END IF
    NEXT

    tLineSeries.nType             = %RMC_LINE
    tLineSeries.nStyle            = %RMC_LINE_FLAT
    tLineSeries.nLineStyle        = %RMC_LSTYLE_SPLINE
    tLineSeries.nColor            = nColor
    aPPC(0) = 52 
    nRetVal = RMC_AddLineSeriesI(%ID_RMC1, 1, aData1(1), nCount,aPPC(0),1, tLineSeries)
END SUB


FUNCTION Show_MissingData(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nDataCount AS LONG
    LOCAL nRetVal AS LONG
    LOCAL sTemp AS STRING
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
    REDIM aData2(0) AS DOUBLE
    REDIM aPPC(0) AS LONG
    REDIM aDates(0) AS STRING
 
    LOCAL nToolTipWidth AS LONG
    
    nToolTipWidth = 100 ' We want to have ToolTips, so we must set the width. To avoid them, set it to zero
    
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorDefault,%RMC_CTRLSTYLEFLAT, _ 
                              %FALSE,"","Tahoma",nToolTipWidth)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add caption to region 1 ******************* 
    nRetval = RMC_AddCaption(%ID_RMC1,1,"DAX on a weekly base with two moving averages and different ToolTips",0,%ColorDarkBlue,9,%TRUE)     
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC1,1,%ColorDefault,%FALSE,0,0,0,0,%RMC_BICOLOR_NONE) 
    '************** Add data axis to region 1 ***************************** 
    ' We only want to show every second tick with a value label, so we format a string, where every second label is empty
    szTemp = "2000**2400**2800**3200**3600**4000**4400**4800**5200**5600**6000**6400**6800**7200**7600**8000"
    nRetVal = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,2000,8000,31,8,%ColorDefault,%ColorDefault,%RMC_LINESTYLESOLID,0,"","",szTemp,%RMC_TEXTCENTER) 
    '************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(%ID_RMC1,1, szTemp,1,7,%RMC_LABELAXISBOTTOM,8,%ColorDefault,%RMC_TEXTCENTER,%ColorDefault,%RMC_LINESTYLESOLID,"") 
    '************** Add Series 1 to region 1 ******************************* 
    aPPC(0) =  52  ' Points per column: weekly data,so 52
    
    
    nRetVal = RMC_ReadDataFromFile(aData(),"dax00-06.csv","-1,1","5",",",0) ' Read the closing values
    nC = nRetVal ' Number of data points
   
    nRetVal = RMC_ReadStringFromFile(aDates(),"dax00-06.csv","-1,1","1",",",0) ' Read the dates
    
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), nC,aPPC(0),1,%RMC_LINE,%RMC_LINE_FLAT,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorNavy,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF) 

    AddMoveAverage aData(),20,%ColorRed   ' Add a moving average, which comprises 20 data points ...
    AddMoveAverage aData(),50,%ColorGreen ' ... and one which comprises 50 data points
    

    FOR i = 1 TO nC ' Number of closing values
        szTemp = "Date: " + aDates(i-1)+$CRLF+"Close: " +FORMAT$(aData(i-1),"0.00") ' Build our own ToolTipText
        RMC_SetCustomToolTipText %ID_RMC1,1,1,i,szTemp                              ' and add it
    NEXT    

    RMC_CODash %ID_RMC1,1,74,69,193,69,0,%ColorRed,0,2,%RMC_ANCHOR_ARROW_OPEN,0
    RMC_COText %ID_RMC1,2,"Period = 20",195,61,0,0,0,0,0,0,0,0,"CB"    
    
    RMC_CODash %ID_RMC1,3,125,94,193,94,0,%ColorGreen,0,2,%RMC_ANCHOR_ARROW_OPEN,0
    RMC_COText %ID_RMC1,4,"Period = 50",195,87,0,0,0,0,0,0,0,0,"CB"    

    RMC_COText %ID_RMC1,5,"Move the mouse pointer over the blue line to see the CustomToolTips." _
                          +$CRLF+"Both average lines have standard ToolTips.", _
                          300,50,250,65,%RMC_BOX_GRADIENTH_SHADOW,%ColorPowderBlue,0,200,0,0,"C9"

    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION    


FUNCTION Show_BarsAndLine(BYVAL hParentDlg AS DWORD) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    LOCAL szTemp AS ASCIIZ * 500
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aPPC(0) AS LONG

    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,670,450,%ColorCornflowerBlue,%RMC_CTRLSTYLEFLATSHADOW,0,"","") 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"data source: F.A.Z",%FALSE) 
    '************** Add caption to region 1 ******************* 
    nRetval = RMC_AddCaption(%ID_RMC1,1,"The world's 10 biggest industrial companies 2003",%ColorCoral,%ColorFloralWhite,12,%TRUE) 
    '************** Add grid to region 1 ***************************** 
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorAzure,%TRUE,0,0,0,0) 
    '************** Add data axis to region 1 ***************************** 
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,100000,250000,11,9,%ColorCornsilk,%ColorBlack,%RMC_LINESTYLESOLID,0,"$","Total turnover in Mill. Dollar") 
    '************** Add second data axis to region 1 ***************************** 
    nRetval = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISRIGHT,0,0,0,0,0,0,0,2,"%","Net operating margin")     
    '************** Add label axis to region 1 ***************************** 
    szTemp =         "Exxon Mobil*Royal Dutch / Shell*BP*General Motors*Daimler Chrysler*Ford Motor*Toyota Motor*General E"
    szTemp = szTemp + "lectric*TOTAL*Chevron Texaco"
    nRetval = RMC_AddLabelAxis(%ID_RMC1,1, szTemp,1,10,%RMC_LABELAXISBOTTOM,8,%ColorCornsilk,%RMC_TEXTCENTER,%ColorBlack,%RMC_LINESTYLESOLID,"") 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    sTemp = "242365*235598*232571*185524*170457*164196*149321*132797*130067*119703"
    nC = RMC_Split2Double(sTemp, aData())
     nRetval = RMC_AddBarSeries(%ID_RMC1,1, aData(0),nC,%RMC_BARSINGLE,%RMC_BAR_FLAT_GRADIENT2,%FALSE,%ColorGold,%FALSE,1,%FALSE,1,%RMC_HATCHBRUSH_OFF) 
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read data values ******
    sTemp = "8.9*4.1*4.4*2.1*.3*.3*5.9*11.3*6.7*6"
    nC = RMC_Split2Double(sTemp, aData())
    nRetval = RMC_AddLineSeries(%ID_RMC1,1, aData(0),nC,0,0,%RMC_LINE,%RMC_LINE_CABLE,%RMC_LSTYLE_LINE,%FALSE, _
                                %ColorGreen,%RMC_SYMBOL_BULLET,2,%TRUE,%RMC_HATCHBRUSH_OFF) 

 
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION

FUNCTION Show_Pie(BYVAL hParentDlg AS DWORD) AS LONG  
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetVal AS LONG
    LOCAL sTemp AS STRING
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
    REDIM aColor(0) AS LONG
 
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorTransparent,%RMC_CTRLSTYLEFLAT,%FALSE,"","Tahoma", 100, %ColorDefault)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read color values ******
    REDIM aColor(3)
    aColor(0) = %ColorMaroon
    aColor(1) = %ColorMediumBlue
    aColor(2) = %ColorCrimson
    aColor(3) = %ColorDefault
    '****** Read data values ******
    REDIM aData(3)
    aData(0) = 80 : aData(1) = 50 : aData(2) = 60 : aData(3) = 30
    nRetVal = RMC_AddGridlessSeries(%ID_RMC1,1, aData(0), 4,aColor(0),4,%RMC_PIE_3D_GRADIENT,%RMC_HALF_TOP,0,%FALSE,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF, 0) 
    '************** Add CustomObjects ******************************* 
    szTemp = "This is a 3D pie with semicricle alignment, tooltips, a custom text and a discreet watermark."
    
    nRetVal = RMC_COText(%ID_RMC1, 1, szTemp,  100,  270,  400,  50, %RMC_BOX_3D_SHADOW, %ColorMoccasin, %ColorDefault,  0, %RMC_LINE_HORIZONTAL, %ColorMaroon, "09C")
 
    nRetVal = RMC_SetWatermark("RMChart",%ColorAutumnOrange,25,1,%RMC_USERFONTSIZE)
    
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?
    
    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
    

     
END FUNCTION



''''''' None-Grid based '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' 
FUNCTION Show_Donut(BYVAL hParentDlg AS DWORD) AS LONG  
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aColor(0) AS LONG
    
    ' No individual color values are defined, so the internal colors are used in this one: 

    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorTransparent,%RMC_CTRLSTYLEIMAGETILED,%FALSE,"paper.jpg","") 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add legend to region 1 ******************************* 
    nRetval = RMC_AddLegend(%ID_RMC1,1,"Apples*Citrons*Bananas*Cherries",%RMC_LEGEND_ONVLABELS, _
                            %ColorGainsboro,%RMC_LEGENDNORECT,%ColorBlue,8,%TRUE) 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_Split2Double("40*30*60*20", aData())
    nRetval = RMC_AddGridlessSeries(%ID_RMC1,1,aData(0),nC,0,0,%RMC_DONUT_GRADIENT,%RMC_FULL,0,%FALSE,%RMC_VLABEL_TWIN,%RMC_HATCHBRUSH_OFF) 
    
    ' Add a CustomObject
    nRetval = RMC_COText(%ID_RMC1,1,"With CustomObjects you can place text wherever you want!",230,175,140,100,0,0,0,0,0,%ColorRed,"12C")

    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION




 
 


FUNCTION Show_XY2Series(BYVAL hParentDlg AS DWORD) AS LONG  
    LOCAL i AS LONG
    
    LOCAL nCX AS LONG
    LOCAL nCY AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aData2(0) AS DOUBLE

    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorAliceBlue,%RMC_CTRLSTYLEFLATSHADOW,0,"","") 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add caption to region 1 ******************* 
    nRetval = RMC_AddCaption(%ID_RMC1,1,"Two XY series aligned to 2 different XY-axes pairs",%ColorBlue,%ColorAntiqueWhite,10,%TRUE) 
    '************** Add grid to region 1 ***************************** 
    nRetval = RMC_AddGrid(%ID_RMC1,1,%ColorBeige,%FALSE,0,0,0,0) 
    '************** Add first X axis to region 1 ***************************** 
    nRetval = RMC_AddXAxis(%ID_RMC1,1,%RMC_XAXISBOTTOM,0,100,11,8,%ColorBlue,%ColorBlue,%RMC_LINESTYLEDOT,0,"","First X axis","") 
    '************** Add first Y axis to region 1 ***************************** 
    nRetval = RMC_AddYAxis(%ID_RMC1,1,%RMC_YAXISLEFT,0,100,11,8,%ColorBlue,%ColorBlue,%RMC_LINESTYLEDOT,0,"","First Y axis","") 
    '************** Add second X axis to region 1 ***************************** 
    nRetval = RMC_AddXAxis(%ID_RMC1,1,%RMC_XAXISTOP,0,10,5,8,%ColorCoral,%ColorCoral,%RMC_LINESTYLEDASH,2,"","Second X axis","") 
    '************** Add second Y axis to region 1 ***************************** 
    nRetval = RMC_AddYAxis(%ID_RMC1,1,%RMC_YAXISRIGHT,0,10,5,8,%ColorCoral,%ColorCoral,%RMC_LINESTYLEDASH,2,"","Second Y axis","") 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read X-data values ******
    nCX = RMC_Split2Double("20*30*60*70*90", aData())
    '****** Read Y-data values ******
    nCY = RMC_Split2Double("40*20*70*10*60", aData2())
    nRetval = RMC_AddXYSeries(%ID_RMC1,1,aData(0),nCX,aData2(0),nCY,%ColorDefault,%RMC_XY_SYMBOL,0,%RMC_SYMBOL_BULLET,%RMC_XAXISBOTTOM,%RMC_YAXISLEFT)
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read X-data values ******
    nCX = RMC_Split2Double("2.5*4.5*5.5*7.5*1.0", aData())
    '****** Read Y-data values ******
    nCY = RMC_Split2Double("7.5*5.5*5.5*2.5*5.0", aData2())
    nRetval = RMC_AddXYSeries(%ID_RMC1,1,aData(0),nCX,aData2(0),nCY,%ColorCoral,%RMC_XY_SYMBOL,0,%RMC_SYMBOL_DIAMOND,%RMC_XAXISTOP,%RMC_YAXISRIGHT,%RMC_VLABEL_DEFAULT)
    
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION


''''''' XY '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' 
FUNCTION Show_SimpleXY(BYVAL hParentDlg AS DWORD) AS LONG  
    LOCAL nRetVal AS LONG
    LOCAL sTemp AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aData2(0) AS DOUBLE
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorSteelBlue,%RMC_CTRLSTYLEFLAT,%FALSE,"") 
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add caption to region 1 ******************* 
    nRetVal = RMC_AddCaption(%ID_RMC1,1,"Simple XY chart",%ColorAliceBlue,%ColorBlack,10,%TRUE) 
    '************** Add grid to region 1 ***************************** 
     nRetVal = RMC_AddGrid(%ID_RMC1,1,%ColorDarkBlue,%FALSE,0,0,0,0) 
    '************** Add first X axis to region 1 ***************************** 
    nRetVal = RMC_AddXAxis(%ID_RMC1,1,%RMC_XAXISBOTTOM,0,100,11,8,%ColorBlanchedAlmond,%ColorWhite,%RMC_LINESTYLENONE,0,"","X Axis","") 
    '************** Add first Y axis to region 1 ***************************** 
    nRetVal = RMC_AddYAxis(%ID_RMC1,1,%RMC_YAXISLEFT,0,100,11,8,%ColorBlanchedAlmond,%ColorBlack,%RMC_LINESTYLENONE,0,"","Y Axis","")     
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read X-data values ******
    REDIM aData(9)
    aData(0) = 10 : aData(1) = 20 : aData(2) = 30 : aData(3) = 40 : aData(4) = 50
    aData(5) = 60 : aData(6) = 70 : aData(7) = 80 : aData(8) = 90 : aData(9) = 10
    '****** Read Y-data values ******
    REDIM aData2(9)
    aData2(0) = 10 : aData2(1) = 30 : aData2(2) = 50 : aData2(3) = 70 : aData2(4) = 90
    aData2(5) = 70 : aData2(6) = 50 : aData2(7) = 30 : aData2(8) = 10 : aData2(9) = 10
    nRetVal = RMC_AddXYSeries(%ID_RMC1,1, aData(0), 10,aData2(0),10,%ColorWhiteSmoke,%RMC_XY_LINE,%RMC_LSTYLE_LINE,%RMC_SYMBOL_STAR,%RMC_XAXISBOTTOM,%RMC_YAXISLEFT, %RMC_VLABEL_NONE)
 
    nRetVal = RMC_SetWatermark($RMC_USERWM,%RMC_USERWMCOLOR,%RMC_USERWMLUCENT,%RMC_USERWMALIGN,%RMC_USERFONTSIZE )
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
     
END FUNCTION

''''''' Miscellaneous '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''' 
FUNCTION Build_ScrollChart(BYVAL hParentDlg AS DWORD) AS LONG 
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    REDIM aPPC(0) AS LONG
    LOCAL tChart AS tRMC_CHART
    LOCAL tRegion AS tRMC_REGION
    LOCAL tCaption AS tRMC_CAPTION
    LOCAL tLegend AS tRMC_LEGEND
    LOCAL tGrid AS tRMC_GRID
    LOCAL tDataAxis AS tRMC_DATAAXIS
    LOCAL tLabelAxis AS tRMC_LABELAXIS
    LOCAL tBarSeries AS tRMC_BARSERIES
    LOCAL tLineSeries AS tRMC_LINESERIES
    LOCAL hOldCursor AS DWORD
 
    hOldCursor = SETCURSOR(hCursorWait)

    ' This example shows, how you can change the data of a chart 'on the fly' without
    ' the necessarity of a complete rebuild of the chart.
    ' This function is only called once, from Function DlgCallback, before setting
    ' the initial data range for the chart.
    ' The call to RMC_Draw for showing the chart also happens in Function DlgCallback,
    ' behind 'CASE %ID_MSC1', after setting the first data range for the chart.
    ' When you scroll the chart, the chart gets refreshed with new data also
    ' in the Callback, behind 'CASE %WM_VSCROLL'
 
    
    '************** Create the chart ********************** 
    tChart.nLeft        = 10  
    tChart.nTop         = 10  
    tChart.nWidth       = 650
    tChart.nHeight      = 500
    tChart.nBackColor   = %ColorDarkTurquoise
    tChart.nCtrlStyle   = %RMC_CTRLSTYLEFLAT
    tChart.nToolTipWidth= 100 ' We want to have ToolTips, so set the width
    nRetVal = RMC_CreateChartI(hParentDlg, %ID_RMC1, tChart)
        
    '************** Add Region 1 ***************************** 
    tRegion.nLeft       = 5
    tRegion.nTop        = 5
    tRegion.nWidth      = -5
    tRegion.nHeight     = -5
    tRegion.sFooter     = "data source: www.yahoo.com"
    tRegion.nShowBorder = %FALSE
    nRetval = RMC_AddRegionI(%ID_RMC1, tRegion) 
    '************** Add caption to region 1 ******************* 
    tCaption.sText  =     "Dow Jones 2000 - 2004"
    tCaption.nBackColor = %ColorDefault
    tCaption.nTextColor = %ColorDefault
    tCaption.nFontSize  = 13
    tCaption.nIsBold    = %TRUE
    nRetval = RMC_AddCaptionI(%ID_RMC1, 1, tCaption)
    '************** Add grid to region 1 ***************************** 
    tGrid.nGridBackColor = %ColorLightSkyBlue
    tGrid.nAsGradient    = %TRUE
    tGrid.nLeft      = 0
    tGrid.nTop       = 0
    tGrid.nWidth     = 0
    tGrid.nHeight    = 0
    nRetval = RMC_AddGridI(%ID_RMC1, 1, tGrid)
    '************** Add data axis to region 1 ***************************** 
    tDataAxis.nAlignment      = %RMC_DATAAXISBOTTOM
    tDataAxis.nMinValue       = 7000
    tDataAxis.nMaxValue       = 12000
    tDataAxis.nTickCount      = 11
    tDataAxis.nFontsize       = 8
    tDataAxis.nTextColor      = %ColorDefault
    tDataAxis.nLineColor      = %ColorDefault
    tDataAxis.nLineStyle      = %RMC_LINESTYLESOLID
    tDataAxis.nDecimalDigits  = 0
    tDataAxis.sUnit           = ""
    tDataAxis.sText           = "Closing Index (Line series)\11"
    nRetval = RMC_AddDataAxisI(%ID_RMC1, 1, tDataAxis)
    '************** Add second data axis to region 1 ***************************** 
    tDataAxis.nAlignment      = %RMC_DATAAXISTOP
    tDataAxis.nMinValue       = 0     
    tDataAxis.nMaxValue       = 30000000
    tDataAxis.nDecimalDigits  = 0
    tDataAxis.sUnit           = ""
    tDataAxis.sText           = "Share volumes (Bar series)\11"
    nRetval = RMC_AddDataAxisI(%ID_RMC1, 1, tDataAxis)
    '************** Add label axis to region 1 ***************************** 
    tLabelAxis.nCount         = 1
    tLabelAxis.nTickCount     = 21
    tLabelAxis.nAlignment     = %RMC_LABELAXISLEFT
    tLabelAxis.nFontsize      = 8
    tLabelAxis.nTextColor     = %ColorDefault
    tLabelAxis.nTextAlignment = %RMC_TEXTCENTER
    tLabelAxis.nLineColor     = %ColorDefault
    tLabelAxis.nLineStyle     = %RMC_LINESTYLESOLID
    nRetval = RMC_AddLabelAxisI(%ID_RMC1, 1, "", tLabelAxis)
    
    '************** Add Series 1 to region 1 ******************************* 
    tBarSeries.nType             = %RMC_BARSINGLE
    tBarSeries.nStyle            = %RMC_BAR_HOVER
    tBarSeries.nIsLucent         = %FALSE
    tBarSeries.nColor            = %ColorLightGoldenrod
    tBarSeries.nIsHorizontal     = %TRUE
    tBarSeries.nWhichDataAxis    = 2
    tBarSeries.nValueLabelOn     = %FALSE
    tBarSeries.nPointsPerColumn  = 1
    tBarSeries.nHatchMode        = %RMC_HATCHBRUSH_OFF
    nRetval = RMC_AddBarSeriesI(%ID_RMC1, 1, 0,0, tBarSeries)

    '************** Add Series 2 to region 1 ******************************* 
    tLineSeries.nType             = %RMC_LINE
    tLineSeries.nStyle            = %RMC_LINE_FASTLINE
    tLineSeries.nLineStyle        = %RMC_LSTYLE_LINE
    tLineSeries.nIsLucent         = %FALSE
    tLineSeries.nColor            = %Red
    tLineSeries.nSeriesSymbol     = %RMC_SYMBOL_POINT_SMALL
    tLineSeries.nWhichDataAxis    = 1
    tLineSeries.nValueLabelOn     = %FALSE
    tLineSeries.nHatchMode        = %RMC_HATCHBRUSH_OFF
    nRetval = RMC_AddLineSeriesI(%ID_RMC1, 1, 0,0,0,0, tLineSeries)
    
    ' Now read the whole data set from file for both series
    ' When scrolling through the chart, the actual data range is set with RMC_SetSeriesDataRange()
    nRetval = RMC_SetSeriesDataFile(%ID_RMC1,1,1, "dowdaily.csv","-1,0","3",",")
    nRetval = RMC_SetSeriesDataFile(%ID_RMC1,1,2, "dowdaily.csv","-1,0","2",",")
    ' Read all labels from the file
    ' When scrolling through the chart, the actual label range is set with RMC_SetLAXLabelsRange()
    nRetval = RMC_SetLAXLabelsFile(%ID_RMC1,1,"dowdaily.csv","-1,0","1",",")
     
    CALL SETCURSOR(hOldCursor)    
    
    FUNCTION = nRetVal

END FUNCTION


FUNCTION TimerChart(BYVAL hParentDlg AS LONG) AS LONG
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
 
    '************** Create the chart **********************
    nRetVal = RMC_CreateChart(hParentDlg, %ID_RMC1, 10, 10, 600, 450, %ColorBlack)
    '************** Add Region 1 *****************************
    nRetVal = RMC_AddRegion(%ID_RMC1, 2, 2, -2, -2)
    '************** Add grid to region 1 *****************************
    nRetVal = RMC_AddGrid(%ID_RMC1, 1, %ColorBlack)
    '************** Add data axis to region 1 *****************************
    nRetVal = RMC_AddDataAxis(%ID_RMC1, 1, %RMC_DATAAXISLEFT, 0, 700, 8, 7, %ColorLimeGreen, %ColorDarkGreen, %RMC_LINESTYLEDOT)
    '************** Add label axis to region 1 *****************************
    nRetVal = RMC_AddLabelAxis(%ID_RMC1, 1, "", 1, 20, %RMC_LABELAXISBOTTOM, 8, %ColorBlack, %RMC_TEXTCENTER, %ColorDarkGreen, %RMC_LINESTYLESOLID, "")
    
    ' Get 20 random values between 100 and 600 for the initial line
    REDIM aTimerData(19)
    FOR i = 0 TO 19
        aTimerData(i) = RMC_RND(10, 680) ' Function in rmchart.dll, returns a random value between 10 and 680
    NEXT
    nRetVal = RMC_AddLineSeries(%ID_RMC1, 1, aTimerData(0), 20, 0, 0, %RMC_LINE, %RMC_LINE_FASTLINE, %RMC_LSTYLE_LINE, %False, _
                                    %ColorLimeGreen)
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION

FUNCTION Show_File(BYVAL hParentDlg AS DWORD) AS LONG 
    LOCAL nRetVal AS LONG
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChartFromFile(hParentDlg,%ID_RMC1,10,10,%FALSE,"4 regions.rmc") 

    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?
    RMC_Draw %ID_RMC1                                                   ' Draw the chart     
END FUNCTION    

FUNCTION Show_DataString(BYVAL hParentDlg AS DWORD) AS LONG 
    LOCAL sTemp AS ASCIIZ * 5000
    LOCAL nRetVal AS LONG
    
    sTemp = sTemp + "00003650|00004450|000051|000061|000071|00008-6697831|00009400|00011Tahoma|100011"
    sTemp = sTemp + "|1000310|1000410|10005-5|10006-5|1000910|100101|100111|100121|100131|100181|1002"
    sTemp = sTemp + "00|100217|1002215|100238|100272|100331|100341|100358|100378|100411|100482|100492"
    sTemp = sTemp + "|10051-6751336|10052-15132304|10053-983041|100541|100558|10056-16777077|10057-16"
    sTemp = sTemp + "777077|100586|10060-16777077|10061-1468806|100622|10180data source: www.federalr"
    sTemp = sTemp + "eserve.gov + www.ecb.int|10181Prime Rates in USA und Euroland|10183%|101871999*"
    sTemp = sTemp + "2000*2001*2002*2003*2004*2005*2006|110011|1100221|110035|1100434|110052|110063|1"
    sTemp = sTemp + "10073|1100970|1101312|110171|11019-16744448|1102115|110221|1102396|110262|110521"
    sTemp = sTemp + "2|110534.75*4.75*4.75*4.75*4.75*5*5*5.25*5.25*5.25*5.5*5.5*5.5*5.75*6*6*6.5*6.5*"
    sTemp = sTemp + "6.5*6.5*6.5*6.5*6.5*6.5*5.5*5.5*5*4.5*4*3.75*3.75*3.5*3*2.5*2*1.75*1.75*1.75*1.7"
    sTemp = sTemp + "5*1.75*1.75*1.75*1.75*1.75*1.75*1.75*1.25*1.25*1.25*1.25*1.25*1.25*1.25*1*1*1*1*"
    sTemp = sTemp + "1*1*1*1*1*1*1*1*1*1*1.25*1.5*1.75*2*2.25*2.25*2.5*2.75*2.75*3*3.25*3.25*3.5*3.75"
    sTemp = sTemp + "*3.75*4*4.25*4.5*4.5*4.75*4.75*5*5.25*5.25*5.25*5.25*5.25*5.25*5.25|120011|12002"
    sTemp = sTemp + "21|120035|1200434|120052|120063|120073|1200950|1201312|120171|12019-2448096|1202"
    sTemp = sTemp + "115|120221|1202396|120262|1205212|120533*3*3*2.5*2.5*2.5*2.5*2.5*2.5*2.5*3*3*3*3"
    sTemp = sTemp + ".25*3.5*3.75*3.75*4.25*4.25*4.5*4.5*4.75*4.75*4.75*4.75*4.75*4.75*4.75*4.5*4.5*4"
    sTemp = sTemp + ".5*4.25*3.75*3.75*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3.25*3."
    sTemp = sTemp + "25*2.75*2.75*2.75*2.5*2.5*2.5*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*2*"
    sTemp = sTemp + "2*2*2*2*2*2.25*2.25*2.25*2.5*2.5*2.5*2.75*2.75*3*3*3.25*3.25*3.5|010011|010054|0"
    sTemp = sTemp + "100721|01014-16744448|010222|01024216*287|01025109*109|010272|010283|010012|0100"
    sTemp = sTemp + "51|01010295|01011102|010191|01026USA (Federal Funds Rate)|010013|010054|0100721|"
    sTemp = sTemp + "01014-10496|010222|01024260*287|01025192*192|010272|010283|010014|010051|0101029"
    sTemp = sTemp + "5|01011185|010191|01026Euroland (Prime Rate)"


    nRetVal = RMC_CreateChartFromFile(hParentDlg,%ID_RMC1,10,10,0,sTemp) ' pass the data string instead of the file name

    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?
    RMC_Draw %ID_RMC1                                                   ' Draw the chart     

END FUNCTION


FUNCTION Show_Transparent(BYVAL hParentDlg AS DWORD) AS LONG 
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nDataCount AS LONG
    LOCAL nRetVal AS LONG
    LOCAL sTemp AS STRING
    REDIM aData(0) AS DOUBLE


    ' In this example we use a transparent bitmap as canvas for the chart. To place it over
    ' the previous painted chart, we create a new control with ID %ID_RMC2. If we would use
    ' ID %ID_RMC1, as in all other examples, the previously painted chart would be destroyed.
    ' If you want to save or print this chart, you must change in Callback DlgCallback under
    ' %ID_EXPORT and %ID_PRINT the chart's ID.
 
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC2, 185, 115, 250, 200,%ColorTransparent,%RMC_CTRLSTYLEFLAT, _
                              %FALSE,"","Tahoma", 0, %ColorTransparent)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC2,5,5,-5,-5) 
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC2,1,%ColorTransparent) 
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC2,1,%RMC_DATAAXISLEFT,0,100,11,8,%ColorBlack,%ColorBlack,%RMC_LINESTYLENONE,0,"","","-") 
    '************** Add label axis to region 1 ***************************** 
    nRetVal = RMC_AddLabelAxis(%ID_RMC2,1, "",1,4,%RMC_LABELAXISBOTTOM,8,%ColorBlack,%RMC_TEXTCENTER,%ColorBlack,%RMC_LINESTYLENONE,"") 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData(3)
    aData(0) = 70 : aData(1) = 20 : aData(2) = 80 : aData(3) = 30
    nRetVal = RMC_AddBarSeries(%ID_RMC2,1,aData(0), 4,%RMC_BARSINGLE,%RMC_COLUMN_FLAT,%FALSE,%ColorMaroon) 
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData(3)
    aData(0) = 30 : aData(1) = 70 : aData(2) = 40 : aData(3) = 80
    nRetVal = RMC_AddLineSeries(%ID_RMC2,1, aData(0), 4,0,0,%RMC_LINE,%RMC_LINE_CABLE_SHADOW,%RMC_LSTYLE_SPLINE,%FALSE, _
                                    %ColorMediumBlue) 
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?

    RMC_Draw %ID_RMC2                                                   ' Draw the chart
    
    nIsChart2 = %TRUE      ' Flag for the existence of the second chart
END FUNCTION

FUNCTION Chart2Bmp(BYVAL hParentDlg AS DWORD) AS LONG 
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nRetval AS LONG
    LOCAL sTemp AS STRING
    REDIM asTemp(0) AS STRING
    REDIM aData(0) AS DOUBLE
    REDIM aColor(0) AS LONG
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,600,450,%ColorTransparent,%RMC_CTRLSTYLEFLAT,%TRUE,"","",0,%ColorTransparent) 
    '************** Add Region 1 *****************************                                  create the chart 
                                                                                                'only for exporting
                                                                                                'and make it transparent
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-5,"",%FALSE) 
    '************** Add legend to region 1 ******************************* 
    nRetval = RMC_AddLegend(%ID_RMC1,1,"Apples*Bananas*Pears*Cherries",%RMC_LEGEND_CUSTOM_UL,%ColorDefault,%RMC_LEGENDNORECT,%ColorDefault,8,%FALSE) 
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    nC = RMC_Split2Double("30.25*26.75*15.89*46.23", aData())
    nRetval = RMC_AddGridlessSeries(%ID_RMC1,1,aData(0),nC,0,0,%RMC_PYRAMIDE3,%RMC_FULL,0,%FALSE,%TRUE,%RMC_HATCHBRUSH_OFF) 
 
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?
    RMC_Draw2File %ID_RMC1,"Demo.png"                                   ' Save the chart
    
    ' If you want to print the chart without painting, 
    ' uncomment the following line:
    ' RMC_Draw2Printer %ID_RMC1                                           ' Send the chart to the default printer
    
    MSGBOX "Chart was saved as 'Demo.png'",%MB_OK OR %MB_ICONINFORMATION, "RMChart Demo"
    CONTROL DISABLE hParentDlg, %ID_PRINT
    CONTROL DISABLE hParentDlg, %ID_EXPORT    
END FUNCTION 





FUNCTION Show_ZoomInternal(BYVAL hParentDlg AS DWORD) AS LONG    
    LOCAL nRetVal AS LONG
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
    REDIM aPPC(0) AS LONG
    LOCAL hOldCursor AS DWORD
 
    hOldCursor = SETCURSOR(hCursorWait)
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,650,500,%ColorDefault,%RMC_CTRLSTYLEFLAT,%FALSE,"","Tahoma", 0, %ColorDefault)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-5,-70,"",%FALSE) 
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC1,1,%ColorDefault,%FALSE,0,0,0,0,%RMC_BICOLOR_NONE) 
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,0,11,8,%ColorDefault,%ColorDefault,%RMC_LINESTYLESOLID,0,"","","",%RMC_TEXTCENTER) 
    '************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(%ID_RMC1,1, szTemp,1,7,%RMC_LABELAXISBOTTOM,8,%ColorDefault,%RMC_TEXTCENTER,%ColorDefault,%RMC_LINESTYLESOLID,"") 
    '************** Add Series 1 to region 1 ******************************* 
    REDIM aPPC(0)
    aPPC(0) = 254
    
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), 0,aPPC(0),1,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorGreen,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF) 
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,1,"dax00-06d.csv","-1,0","3",",",0)

    '************** Add Series 2 to region 1 ******************************* 
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), 0,aPPC(0),1,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorRed,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,2,"dax00-06d.csv","-1,0","4",",",0)
    '************** Add Series 3 to region 1 *******************************     
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), 0,aPPC(0),1,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorBlue,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,3,"dax00-06d.csv","-1,0","7",",",0)    
    
    nRetVal = RMC_AddLegend(%ID_RMC1,1,"High*Low*Close",%RMC_LEGEND_TOP)
    
    szTemp = "Draw a rectangle with the left mouse button pressed around the area, "
    szTemp = szTemp + "which shall be zoomed, then release the button."+$CRLF+"With a right mouse button click (backwards) and a Shift+"
    szTemp = szTemp + "right mouse button click (forwards) you can browse between multiple zoom states."+$CRLF
    szTemp = szTemp + "The middle mouse button redraws the original (unzoomed) chart."
    nRetVal = RMC_COText(%ID_RMC1, 1, szTemp,  35,  435,  610,  60, %RMC_BOX_FLAT_SHADOW, %ColorDefault, _
                         %ColorDefault,  0, %RMC_LINE_HORIZONTAL, %ColorDefault, "00C")    
    
    RMC_Zoom %ID_RMC1,%RMC_ZOOM_INTERNAL,%ColorRed,%ColorBlue,100 

    CALL SETCURSOR(hOldCursor)
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?
    
    RMC_Draw %ID_RMC1
    
    
END FUNCTION

FUNCTION Show_ZoomExternal(BYVAL hParentDlg AS DWORD) AS LONG    
    LOCAL nRetVal AS LONG
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
    REDIM aPPC(0) AS LONG
    LOCAL hOldCursor AS DWORD
 
    hOldCursor = SETCURSOR(hCursorWait)
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,800,250,%ColorDefault,%RMC_CTRLSTYLEFLAT,%FALSE,"","Tahoma", 0, %ColorDefault)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-100,-5,"",%FALSE) 
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC1,1,%ColorDefault,%FALSE,0,0,0,0,%RMC_BICOLOR_NONE) 
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,0,11,8,%ColorDefault,%ColorDefault,%RMC_LINESTYLESOLID,0,"","","",%RMC_TEXTCENTER) 
    '************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(%ID_RMC1,1, szTemp,1,7,%RMC_LABELAXISBOTTOM,8,%ColorDefault,%RMC_TEXTCENTER,%ColorDefault,%RMC_LINESTYLESOLID,"") 
    '************** Add Series 1 to region 1 ******************************* 
    REDIM aPPC(0)
    aPPC(0) = 254
    
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), 0,aPPC(0),1,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorGreen,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF) 
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,1,"dax00-06d.csv","-1,0","3",",",0)

    '************** Add Series 2 to region 1 ******************************* 
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), 0,aPPC(0),1,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorRed,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,2,"dax00-06d.csv","-1,0","4",",",0)
    '************** Add Series 3 to region 1 *******************************     
    nRetVal = RMC_AddLineSeries(%ID_RMC1,1, aData(0), 0,aPPC(0),1,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorBlue,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,3,"dax00-06d.csv","-1,0","7",",",0)    
    
    nRetVal = RMC_AddLegend(%ID_RMC1,1,"High*Low*Close",%RMC_LEGEND_TOP)
    
    szTemp = "Draw a rectangle with the left mouse button pressed around the area, "
    szTemp = szTemp + "which shall be zoomed, then release the button."
        nRetVal = RMC_COText(%ID_RMC1, 1, szTemp,  710,  40, 80 ,150, %RMC_BOX_FLAT_SHADOW, %ColorDefault, _
                         %ColorDefault,  0, %RMC_LINE_HORIZONTAL, %ColorDefault, "00C")    
    
    RMC_Zoom %ID_RMC1,%RMC_ZOOM_EXTERNAL,%ColorRed,%ColorBlue,100 

 
    
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?
    
    RMC_Draw %ID_RMC1
    
    '************** Create a second chart for showing the zoomed area  ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC2, 10, 270, 800, 300,%ColorDefault,%RMC_CTRLSTYLEFLAT, _
                              %FALSE,"","Tahoma", 0, %ColorDefault)
                              
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC2,5,5,-5,-5,"",%FALSE) 
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC2,1,%ColorDefault,%FALSE,0,0,0,0,%RMC_BICOLOR_NONE) 
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC2,1,%RMC_DATAAXISLEFT,0,0,11,8,%ColorDefault,%ColorDefault,%RMC_LINESTYLESOLID,0,"","","",%RMC_TEXTCENTER) 
    '************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(%ID_RMC2,1, szTemp,1,7,%RMC_LABELAXISBOTTOM,8,%ColorDefault,%RMC_TEXTCENTER,%ColorDefault,%RMC_LINESTYLESOLID,"") 
    '************** Add Series 1 to region 1 ******************************* 
    REDIM aPPC(0)
    aPPC(0) = 254
    
    nRetVal = RMC_AddLineSeries(%ID_RMC2,1, aData(0), 0,0,0,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorGreen,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF) 
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC2,1,1,"dax00-06d.csv","-1,0","3",",",0)

    '************** Add Series 2 to region 1 ******************************* 
    nRetVal = RMC_AddLineSeries(%ID_RMC2,1, aData(0), 0,0,0,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorRed,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC2,1,2,"dax00-06d.csv","-1,0","4",",",0)
    '************** Add Series 3 to region 1 *******************************     
    nRetVal = RMC_AddLineSeries(%ID_RMC2,1, aData(0), 0,0,0,%RMC_LINE,%RMC_LINE_FASTLINE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorBlue,%RMC_SYMBOL_NONE,1,%RMC_VLABEL_NONE,%RMC_HATCHBRUSH_OFF)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC2,1,3,"dax00-06d.csv","-1,0","7",",",0)    
    
    nRetVal = RMC_AddLegend(%ID_RMC2,1,"High*Low*Close",%RMC_LEGEND_TOP)
                                  
    nIsChart2 = %TRUE
 
    CALL SETCURSOR(hOldCursor)   
    
    FUNCTION = nRetVal
    IF nRetVal < 0 THEN EXIT FUNCTION                                   ' Error?    
    
END FUNCTION


SUB Show_ZoomedArea(TINFO AS tRMC_INFO)
    REGISTER i&
    LOCAL nFirst&,nLast&,nFirstCol&,nLastCol&,nColIndex&,nOldColIndex&,y&
    LOCAL aPointsPerCol() AS LONG
    LOCAL tINFO2 AS tRMC_INFO
    
    IF TINFO.nData1 <> 0 THEN  ' if the rectangle covers data
        ' nData1 holds the information about the first series. 
        nFirst = LO(DWORD,TINFO.nData1) ' the (first) data index of the first element, which is covered by the rectangle
        nLast = HI(DWORD,TINFO.nData1)  ' the (last) data index of the last element, which is covered by the rectangle
        RMC_SetSeriesDataRange %ID_RMC2,1,1,nFirst,nLast    ' set the new data range for series 1
        ' The three series (which show the high,low and close value of DAX at each day) belong together,
        ' so we will not check .nData2 and .nData3 for the nFirst and nLast values, they must have the same index values
        ' as for the first series. We will simply set the DataRange for series 2 and 3 the same as for series 1:
        RMC_SetSeriesDataRange %ID_RMC2,1,2,nFirst,nLast    ' set the new data range for series 2
        RMC_SetSeriesDataRange %ID_RMC2,1,3,nFirst,nLast    ' set the new data range for series 3                
        
        ' To keep it simple, we could now set the label axis to one column and show the lines evenly spread in this column,
        ' as it is always done, when using the internal zooming mode (check example "Zoom internal").
        ' Uncomment the next four lines to see the chart:
        ' RMC_SetLAXTickCount %ID_RMC2,1,1      ' only one column on the label axis
        ' RMC_SetLAXLabelsRange %ID_RMC2,1,-1,-1  ' show no labels 
        ' RMC_Draw %ID_RMC2                     ' draw the zoomed area chart   
        ' EXIT SUB                              
        
        ' But we want to show the data points of the lines in the columns of the label axis, where they belong to.
        ' so we must check each data point for it's column index, and we must count, how many data points belong
        ' to each column:

        FOR i = nFirst TO nLast
            RMC_GetINFO %ID_RMC1,tINFO2,1,1,i
            nColIndex = tINFO2.nGCol                ' ColumnIndex of the data point
            IF nFirstCol=0 THEN nFirstCol=nColIndex ' Mark the first label for the label axis
            IF nColIndex>nOldColIndex THEN          ' New ColumnIndex? 
                INCR y                              ' Incr Column count 
                IF y = 1 THEN
                    REDIM aPointsPerCol(1 TO 1)     ' (Re)Dimension the PointsPerColumn-Array
                ELSE
                    REDIM PRESERVE aPointsPerCol(1 TO y)
                END IF
                nOldColIndex = nColIndex
            END IF
            INCR aPointsPerCol(y)                   ' Increment the counter for the PointsPerColumn for this Column
        NEXT
        nLastCol = nColIndex                        ' Mark the last label for the label axis  
        
        RMC_SetLAXTickCount %ID_RMC2,1,y            ' Set the number of columns
        FOR i = 1 TO 3
            RMC_SetSeriesPPColumnArray %ID_RMC2,1,i,aPointsPerCol(1),y ' set the PointsPerColumn (for each series identical)
        NEXT
        RMC_SetLAXLabelsRange %ID_RMC2,1,nFirstCol,nLastCol ' Set the range for the labels on the label axis
        RMC_Draw %ID_RMC2                           ' Draw the zoomed area chart
    
    ELSE                        ' if the rectangle covers no data
        FOR i = 1 TO 3
            RMC_SetSeriesDataRange %ID_RMC2,1,i,-1,-1  ' set series range to zero
        NEXT    
        RMC_SetLAXTickCount %ID_RMC2,1,1
        RMC_SetLAXLabelsRange %ID_RMC2,1,-1,-1
        RMC_Draw %ID_RMC2 ' Redraw the lower chart control  
    END IF                        
    
END SUB    



FUNCTION Show_Magnifier(BYVAL hParentDlg AS DWORD) AS LONG    
    LOCAL nRetVal AS LONG
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
    REDIM aPPC(0) AS LONG
    LOCAL hOldCursor AS DWORD
 
    hOldCursor = SETCURSOR(hCursorWait)
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC1,10,10,800,250,%ColorDefault,%RMC_CTRLSTYLEFLAT,%FALSE,"","Tahoma", 0, %ColorDefault)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC1,5,5,-150,-5,"",%FALSE) 
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC1,1,%ColorDefault,%FALSE,0,0,0,0,%RMC_BICOLOR_NONE) 
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC1,1,%RMC_DATAAXISLEFT,0,0,11,8,%ColorDefault,%ColorDefault,%RMC_LINESTYLESOLID,0,"","","",%RMC_TEXTCENTER) 
    '************** Add label axis to region 1 ***************************** 
    szTemp = "2000*2001*2002*2003*2004*2005*2006"
    nRetVal = RMC_AddLabelAxis(%ID_RMC1,1, szTemp,1,7,%RMC_LABELAXISBOTTOM,8,%ColorDefault,%RMC_TEXTCENTER,%ColorDefault,%RMC_LINESTYLESOLID,"") 
    '************** Add Series 1 to region 1 ******************************* 
    REDIM aPPC(0)
    aPPC(0) = 254
    
    nRetVal = RMC_AddHighLowSeries(%ID_RMC1,1,0,0,aPPC(0),1)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC1,1,1,"dax00-06d.csv","-1,0","2-5",",",0)


    szTemp = "Click with the left mouse button onto the chart and move the blue rectangle over the HighLow series. "
    szTemp = szTemp + "The magnification of this area is shown in the lower chart control."+$CRLF+$CRLF
    szTemp = szTemp + "Shift + right mouse click enlarges the rectangle, Shift + left mouse click makes it smaller."
    nRetVal = RMC_COText(%ID_RMC1, 1, szTemp,  670,  10,  120,  220, %RMC_BOX_FLAT_SHADOW, %ColorDefault, _
                         %ColorDefault,  0, %RMC_LINE_HORIZONTAL, %ColorDefault, "00C")    


    RMC_Magnifier %ID_RMC1,%TRUE,20,%ColorBlue,0,100


    FUNCTION = nRetVal
    IF nRetVal < 0 THEN 
        CALL SETCURSOR(hOldCursor)    
        EXIT FUNCTION                                   ' Error?
    END IF    
    
    RMC_Draw %ID_RMC1
    
    
    '************** Create a second chart for the magnifier ********************** 
    nRetVal = RMC_CreateChart(hParentDlg,%ID_RMC2, 10, 270, 800, 300,%ColorDefault,%RMC_CTRLSTYLEFLAT, _
                              %FALSE,"","Tahoma", 0, %ColorDefault)
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC2,5,5,-5,-5,"",%FALSE) 
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC2,1,%ColorDefault,%FALSE,0,0,0,0,%RMC_BICOLOR_NONE) 
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC2,1,%RMC_DATAAXISLEFT,0,0,11,8) 
    '************** Add label axis to region 1 ***************************** 
    nRetVal = RMC_AddLabelAxis(%ID_RMC2,1,"",0,1,%RMC_LABELAXISBOTTOM,8,%ColorBlack,%RMC_TEXTCENTER,%ColorBlack,%RMC_LINESTYLENONE,"")         
    
    aPPC(0) = 1    
    nRetVal = RMC_AddHighLowSeries(%ID_RMC2,1,0,0,0,0)
    nRetVal = RMC_SetSeriesDataFile(%ID_RMC2,1,1,"dax00-06d.csv","-1,0","2-5",",",0)    
    
    nIsChart2 = %TRUE
    
    CALL SETCURSOR(hOldCursor)    

    
END FUNCTION


SUB Show_Magnification(TINFO AS tRMC_INFO)
    LOCAL nFirst&,nLast&
    IF TINFO.nData1 <> 0 THEN  ' if the rectangle covers data
        ' nData1 holds the information about the first series. Because we have only one series,
        ' we don't have to check nData2 - nVirtData4 for the infos about other series.
        nFirst = LO(DWORD,TINFO.nData1) ' the (first) data index of the first element, which is covered by the rectangle
        nLast = HI(DWORD,TINFO.nData1)  ' the (last) data index of the last element, which is covered by the rectangle
        RMC_SetSeriesDataRange %ID_RMC2,1,1,nFirst,nLast    ' set the new data range
        
        
        RMC_Draw %ID_RMC2 ' Redraw the lower chart control
    ELSE                        ' if the rectangle covers no data
        RMC_SetSeriesDataRange %ID_RMC2,1,1,-1,-1  ' set series range to zero
        RMC_Draw %ID_RMC2 ' Redraw the lower chart control  
    END IF                    
END SUB

    
CALLBACK FUNCTION DlgCallback
    LOCAL i          AS LONG
    LOCAL nError     AS LONG
    LOCAL nResult    AS LONG
    LOCAL hDC        AS LONG
    LOCAL x          AS LONG
    LOCAL sLines     AS ASCIIZ * 20
    REDIM aData1(0)  AS DOUBLE
    REDIM aData2(0)  AS DOUBLE
    REDIM aLabels(0) AS STRING
    LOCAL TINFO    AS tRMC_INFO POINTER
    LOCAL nFirst#,nLast#,nData#,nL&,nT&,nR&,nB&,nPos&,nC&

    STATIC nLButtonDown&, nOldX&, nOldY&
    

    SELECT CASE CBMSG
        CASE %WM_TIMER     ' every time a timer message comes in (see TimerChart)
            FOR i = 0 TO 18
                aTimerData(i) = aTimerData(i+1)
            NEXT    
            aTimerData(19) = RMC_RND(10, 680) ' Function in rmchart.dll, returns a random value between 10 and 680
            RMC_SetSeriesData %ID_RMC1,1,1,aTimerData(0),20 ' Set the new data values
            RMC_Draw %ID_RMC1                          ' (Re)draw the chart                                   
        CASE %WM_COMMAND
            CONTROL ENABLE CBHNDL, %ID_PRINT
            CONTROL ENABLE CBHNDL, %ID_EXPORT
    
            SELECT CASE CBCTL
                CASE %ID_CLOSE
                    DIALOG END CBHNDL
                CASE %ID_EXPORT
                    ExportTheChart CBHNDL, %ID_RMC1                           
                CASE %ID_PRINT                    
                    nResult = PrinterDialog1(CBHNDL,0,hDC,1,1,1,1,1)
                    IF ISTRUE(nResult) THEN
                        DIALOG REDRAW CBHNDL
                        RMC_Draw2Printer %ID_RMC1, hDC    
                    END IF                      
                CASE %ID_GB1
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it
                    nError = Show_Bars(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo" 
                CASE %ID_GB2
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_GroupedBars(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                     
                CASE %ID_GB3
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_StackedBars(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo" 
                CASE %ID_GB10
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_FloatingBars(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                                         
                CASE %ID_GB4
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %TRUE ' allow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_Line(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_GB5
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_3Lines(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_GB6
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_BarsAndLine(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_GB7
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                    
                    nError = Show_MissingData(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                    
                CASE %ID_GB8
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_BarsImage(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                     
                CASE %ID_MSC7
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    nError = Show_Transparent(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_NGB2
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_Donut(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_NGB1
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_Pie(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                    
                CASE %ID_XY1
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_XY2Series(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_XY2
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_SimpleXY(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_MSC1
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_SHOW		
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    siH.cbSize = SIZEOF(siH)
                    siH.fMask = %SIF_RANGE OR %SIF_PAGE
                    siH.nMin = 1
                    siH.nMax = 1256           ' 1256 days total
                    siH.nPage = 21            ' 21 days shall be painted 
                    CONTROL HANDLE CBHNDL, %ID_SCROLL TO lScrH
                    SETSCROLLINFO lScrH, %SB_CTL, siH, %TRUE                              
                    ' Call the Sub which builds the chart, but does not show it
                    nError = Build_ScrollChart(CBHNDL)  
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                    ' Set the initial data range
                    RMC_SetSeriesDataRange %ID_RMC1,1,1,1,21
                    RMC_SetSeriesDataRange %ID_RMC1,1,2,1,21
                    ' Set the initial range for the labels
                    RMC_SetLAXLabelsRange %ID_RMC1,1,1,21
                    RMC_Draw %ID_RMC1   ' Draw the chart for the first time
                CASE %ID_MSC2
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_File(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"
                CASE %ID_MSC3
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it
                    nError = Chart2Bmp(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"            
                CASE %ID_MSC4     ' TimerChart example
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    SETTIMER CBHNDL, 1, 250, BYVAL 0 ' initialize the timer with a time-out value of 0 milliseconds ("real time")
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = TimerChart(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                                
                CASE %ID_MSC5
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_DataString(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                                        
                CASE %ID_MSC6
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    MiniDesigner CBHNDL                    
                CASE %ID_MSC8
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_ZoomInternal(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                                        
                CASE %ID_MSC9
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_Magnifier(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                                                            
                CASE %ID_MSC10
                    CONTROL SHOW STATE CBHNDL, %ID_SCROLL,%SW_HIDE	
                    nChangeData = %FALSE ' disallow changing the data with a mouseclick                    
                    KILLTIMER CBHNDL,1                        ' Kill the timer 
                    IF nIsChart2 THEN RMC_DeleteChart %ID_RMC2 : nIsChart2 = 0  ' If second chart is existing, delete it                                        
                    nError = Show_ZoomExternal(CBHNDL) 
                    IF nError THEN MSGBOX "Error " + STR$(nError), %MB_OK OR %MB_ICONERROR,"RMChart Demo"                                                            
                CASE %ID_RMC1         ' Message from the chart control
                    SELECT CASE CBCTLMSG
                        CASE %RMC_LBUTTONDOWN     ' Left mousebutton clicked
                            nLButtonDown = %TRUE  ' Set flag 
                            TINFO = CBLPARAM    ' lParam holds a pointer to a tRMC_INFO structure    
                            IF nChangeData THEN   ' if in the first line chart
                                IF @TINFO.nGCol > 0 THEN
                                   ' Set the new data
                                    x=RMC_SetSeriesSingleData(%ID_RMC1,1,1,@TINFO.nVirtData1,@TINFO.nGCol)

                                    ' Refresh the trend line
                                    ' Calc the trend and get the needed X/Y positions (nL,nT,nR,nB) for the line
                                    RMC_CalcTrend %ID_RMC1,1,1,nFirst,nLast,nL,nT,nR,nB                                           

                                    ' Add a CustomLine to show the new trend:
                                    RMC_CODash %ID_RMC1,1,nL,nT,nR,nB,%RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,%ColorRed,%ColorGreen),0,2,0,%RMC_ANCHOR_ARROW_CLOSED
                                    
                                    ' Draw the "legend" for the trend line:
                                    RMC_CODash %ID_RMC1,2,470,11,500,11,%RMC_LINE_FLAT_DASH,IIF(nFirst>nLast,%ColorRed,%ColorGreen),0,2
                                    RMC_COText %ID_RMC1,3,"Trend",505,5
                                    
                                    ' Draw the chart with the new data and the trend line
                                    IF x=0 THEN nError=RMC_DRAW(%ID_RMC1)
                                END IF    
                            END IF
                            IF @TINFO.nChartType = %RMC_MAGNIFIER_MODE THEN ' if in magnification mode
                                Show_Magnification @TINFO   ' show the magnification
                            END IF
                            ' See RMC_LBUTTONUP, RMC_ZOOM_MODE:
                            nOldX = @TINFO.nXPos : nOldY = @TINFO.nYPos
                        CASE %RMC_SHIFTLBUTTONDOWN                            
                            TINFO = CBLPARAM    ' lParam holds a pointer to a tRMC_INFO structure    
                            IF @TINFO.nChartType = %RMC_MAGNIFIER_MODE THEN ' if in magnification mode
                                Show_Magnification @TINFO   ' show the magnification
                            END IF
                        CASE %RMC_SHIFTRBUTTONDOWN                            
                            TINFO = CBLPARAM    ' lParam holds a pointer to a tRMC_INFO structure    
                            IF @TINFO.nChartType = %RMC_MAGNIFIER_MODE THEN ' if in magnification mode
                                Show_Magnification @TINFO   ' show the magnification
                            END IF                                                           
                        CASE %RMC_CTRLLBUTTONDOWN     ' CtrlLeft mousebutton clicked
                            TINFO = CBLPARAM      ' lParam holds a pointer to a tRMC_INFO structure
                            ShowInfo @TINFO       ' Show the content of this structure
                        CASE %RMC_MOUSEMOVE
                            IF nLButtonDown AND nIsChart2 THEN
                                TINFO = CBLPARAM
                                IF @TINFO.nChartType = %RMC_MAGNIFIER_MODE THEN ' if in magnification mode
                                    Show_Magnification @TINFO   ' show the magnification
                                END IF
                            END IF            
                        CASE %RMC_LBUTTONUP
                            nLButtonDown = %FALSE  ' Reset flag 
                            IF nIsChart2 THEN
                                TINFO = CBLPARAM
                                IF @TINFO.nChartType = %RMC_ZOOM_MODE THEN ' if in zoom mode
                                    Show_ZoomedArea @TINFO   ' show the zoomed area
                                END IF
                            END IF            
                    END SELECT                         
            END SELECT                
        CASE %WM_VSCROLL            ' the vertical scrollbar from "Scroll chart" (see Function Build_ScrollChart)
            SELECT CASE LOWRD(CBWPARAM)
                sih.cbSize = SIZEOF(sih)            
                sih.fMask = %SIF_ALL
                GETSCROLLINFO lScrH, %SB_CTL, sih
                CASE %SB_LINEDOWN
                    sih.nPos = MIN(sih.nPos + 1,(sih.nMax-sih.nPage)+1)
                CASE %SB_LINEUP 
                    sih.nPos = MAX(1,sih.nPos - 1)
                CASE %SB_PAGEUP                                                        
                    sih.nPos = MAX(1,sih.nPos - (sih.nPage-1))
                CASE %SB_PAGEDOWN                                                      
                    sih.nPos = MIN(sih.nPos + (sih.nPage-1),(sih.nMax-sih.nPage)+1)
                CASE %SB_THUMBTRACK    
                    sih.nPos = HIWRD(CBWPARAM)
                CASE %SB_TOP
                    sih.nPos = 1
                CASE %SB_BOTTOM 
                    sih.nPos = (sih.nMax-sih.nPage)+1
                CASE ELSE          
                    FUNCTION = %TRUE
                    EXIT FUNCTION               
            END SELECT                 
            SETSCROLLINFO lScrH, %SB_CTL, sih, %TRUE        
            nFirst = sih.nPos
            nLast = nFirst + 20
            ' Set the new data range for the first series (Bars):
            RMC_SetSeriesDataRange %ID_RMC1,1,1,nFirst,nLast
            ' Set the new data range for the second series (Line):
            RMC_SetSeriesDataRange %ID_RMC1,1,2,nFirst,nLast
            ' Set the new range for the lables of the label axis
            RMC_SetLAXLabelsRange %ID_RMC1,1,nFirst,nLast
            nError = RMC_Draw(%ID_RMC1) ' Show the chart with the new data
    END SELECT        
END FUNCTION


FUNCTION PBMAIN()
    LOCAL nResult        AS LONG
    LOCAL hDlg           AS DWORD
    LOCAL hMenu          AS LONG
    LOCAL hPopup1        AS LONG
    LOCAL hPopup2        AS LONG
    LOCAL hPopup3        AS LONG
    LOCAL hPopup4        AS LONG    
    LOCAL nDlgH          AS LONG
    LOCAL nDlgW          AS LONG

    nDlgW = 650
    nDlgH = 400

    DIALOG NEW 0, "RMChart Demo", , , nDlgW&, nDlgH&, _
               %DS_CENTER OR %WS_SYSMENU OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_CAPTION OR %WS_THICKFRAME, _
               %WS_EX_CONTROLPARENT TO hDlg
    CONTROL ADD BUTTON, hDlg, %ID_EXPORT,"&Save bitmap",(nDlgW/2) - 85,nDlgH-40,50,15
    CONTROL ADD BUTTON, hDlg, %ID_PRINT,"&Print",(nDlgW/2) - 25,nDlgH-40,50,15
    CONTROL ADD BUTTON, hDlg, %ID_CLOSE, "&End",(nDlgW/2) + 35,nDlgH-40,50,15
    CONTROL ADD SCROLLBAR, hDlg,%ID_SCROLL,"",440,6,12,308,%SBS_VERT OR %WS_TABSTOP	
    CONTROL SET COLOR hDlg,%ID_SCROLL,%BLACK,%WHITE    
    CONTROL DISABLE hDlg, %ID_PRINT
    CONTROL DISABLE hDlg, %ID_EXPORT
    CONTROL SHOW STATE hDlg, %ID_SCROLL,%SW_HIDE	

    MENU NEW BAR TO hMenu
    MENU NEW POPUP TO hPopup1
    MENU NEW POPUP TO hPopup2
    MENU NEW POPUP TO hPopup3
    MENU NEW POPUP TO hPopup4
    MENU ADD POPUP,  hMenu, "&Grid-based", hPopup1, %MF_ENABLED
    MENU ADD STRING, hPopup1, "Single bars", %ID_GB1, %MF_ENABLED
    MENU ADD STRING, hPopup1, "Grouped bars", %ID_GB2, %MF_ENABLED
    MENU ADD STRING, hPopup1, "Stacked bars", %ID_GB3, %MF_ENABLED
    MENU ADD STRING, hPopup1, "Floating bars", %ID_GB10, %MF_ENABLED    
    MENU ADD STRING, hPopup1, "Bars with diff. colors and BgImage", %ID_GB8, %MF_ENABLED    
    MENU ADD STRING, hPopup1, "-" , 0, 0
    MENU ADD STRING, hPopup1, "Line with a trend line", %ID_GB4, %MF_ENABLED
    MENU ADD STRING, hPopup1, "Indexed lines", %ID_GB5, %MF_ENABLED
    MENU ADD STRING, hPopup1, "Lines with missing data", %ID_GB7, %MF_ENABLED
    MENU ADD STRING, hPopup1, "-" , 0, 0
    MENU ADD STRING, hPopup1, "Bars and line", %ID_GB6, %MF_ENABLED
    
    MENU ADD POPUP,  hMenu, "&Non-grid based", hPopup2, %MF_ENABLED
    MENU ADD STRING, hPopup2, "Donut with image", %ID_NGB2, %MF_ENABLED
    MENU ADD STRING, hPopup2, "Pie", %ID_NGB1, %MF_ENABLED
    
    MENU ADD POPUP,  hMenu, "&XY scatter", hPopup3, %MF_ENABLED    
    MENU ADD STRING, hPopup3, "Simple XY", %ID_XY2, %MF_ENABLED
    MENU ADD STRING, hPopup3, "XY with 2 series", %ID_XY1, %MF_ENABLED
    
        
    MENU ADD POPUP,  hMenu, "&Miscellaneous", hPopup4, %MF_ENABLED    
    MENU ADD STRING, hPopup4, "Scroll chart", %ID_MSC1, %MF_ENABLED
    MENU ADD STRING, hPopup4, "Timer chart", %ID_MSC4, %MF_ENABLED
    MENU ADD STRING, hPopup4, "Draw chart from data string", %ID_MSC5, %MF_ENABLED    
    MENU ADD STRING, hPopup4, "Transparent control", %ID_MSC7, %MF_ENABLED
    MENU ADD STRING, hPopup4, "Draw chart from file", %ID_MSC2, %MF_ENABLED
    MENU ADD STRING, hPopup4, "Save chart without painting", %ID_MSC3, %MF_ENABLED
    MENU ADD STRING, hPopup4, "-", 0,0
    MENU ADD STRING, hPopup4, "Zoom internal", %ID_MSC8, %MF_ENABLED
    MENU ADD STRING, hPopup4, "Zoom external", %ID_MSC10, %MF_ENABLED
    MENU ADD STRING, hPopup4, "Magnifier", %ID_MSC9, %MF_ENABLED
    MENU ADD STRING, hPopup4, "-", 0,0
    MENU ADD STRING, hPopup4, "MiniDesigner", %ID_MSC6, %MF_ENABLED
    MENU ATTACH hMenu, hDlg

    hCursorWait = LOADCURSOR(BYVAL 0&, BYVAL %IDC_WAIT)


    DIALOG SHOW MODAL hDlg, CALL DlgCallback TO nResult
END FUNCTION











' *********************************** MiniDesigner *********************************************


SUB ShowMDInfo()
    DIM sInfo$
    
    sInfo = "The important message of the 'MiniDesigner' is not," + $CRLF _
            +"what can be done with it, but how is it done. Play with" + $CRLF _
            +"it and check CALLBACK FUNCTION MDCallback in the source" + $CRLF _
            +"to see, how it works." + $CRLF _
            +"You can see mouse support in action and how easy it is to change"  + $CRLF _
            +"the properties of an existing chart. Maybe this gives you some" + $CRLF _
            +"ideas for your own work with RMChart."+ $CRLF+ $CRLF _
            +" - Change the properties of the chart"+ $CRLF _
            +" - Check/uncheck 'Show the cloned chart'"+ $CRLF _
            +" - Resize/Maximize the dialog"+ $CRLF _
            +" - Press the middle mouse button/ mouse wheel and move the upper chart"+ $CRLF _
            +" - Click with ctrl+left mouse button onto different parts of the upper chart"+ $CRLF _
            +" - Click and hold with left mouse button onto a bar and move up and down"+ $CRLF _
            +" - Click with the right mouse button into the grid"+ $CRLF _            
            +" - Click with ctrl+right mouse button into the grid"+ $CRLF _
            +" - Click with shift+right mouse button into the grid" + $CRLF _
            +" - Click with shift+left mouse button on the red bullet in the upper chart," + $CRLF _
            +"   hold mouse button down and move the cursor." 
                
    MSGBOX sInfo,%MB_OK OR %MB_ICONINFORMATION,"RMChart Demo"              
END SUB


' Draws the upper and (if visible) the lower chart
SUB DrawCharts() 
    LOCAL szTemp AS ASCIIZ * 2000
    RMC_Draw %ID_RMC2              ' Draw the upper chart
    IF nShowClone THEN             ' if the lower chart is vivible
        RMC_WriteRMCFile %ID_RMC2,szTemp ' get the data string from the upper chart
        RMC_SetRMCFile %ID_RMC3,szTemp   ' Set the data string in the existent lower chart
        RMC_SetCaptionText %ID_RMC3,1,"I'm the clone" ' change the caption from "I'm the original"
        RMC_Draw %ID_RMC3                ' Draw the lower chart  
    END IF    
END SUB    

' Callback function for the MiniDesigner, everything important happens here!
CALLBACK FUNCTION MDCallback         
    LOCAL nError&,nResult&,hDC&,x&,y&,nW&,nH&
    LOCAL aData() AS DOUBLE
    LOCAL szTemp AS ASCIIZ * 2000
    LOCAL TINFO   AS tRMC_INFO POINTER
    LOCAL tRect AS RECT
    
    STATIC nLBDN&,nMBDN&,nShLBDn&    ' for status of the Left and Middle mousebutton
    STATIC nC&
    
    SELECT CASE CBMSG
        CASE %WM_CREATE
            nLBDN = 0 
        CASE %WM_SIZE
            x = LOWRD(CBLPARAM) : y = HIWRD(CBLPARAM)
            ' set the size of the upper chart, dependend on status of flag 'nShowClone'
            RMC_SetCtrlSize %ID_RMC2,x-320,y-80 - IIF(nShowClone,y/2-40,0),0,1
            IF nShowClone THEN ' if the lower chart is visible
                ' set the lower chart size ...
                RMC_SetCtrlSize %ID_RMC3,x-320,(y-40) - (y/2),0,1
                ' ... and position
                RMC_SetCtrlPos %ID_RMC3,300,(y/2)
            END IF            
        CASE %WM_COMMAND
            SELECT CASE CBCTL          ' select which control sends a message        
                CASE %ID_CB_COLOROBJ   ' Color object combobox
                    IF CBCTLMSG = %CBN_SELCHANGE THEN	
                        x = COMBOGETSELDATA(CBHNDL,%ID_CB_COLOROBJ)  ' Index of the selected object
                        COMBOSETINDEXDATA CBHNDL,%ID_CB_COLOR,aCurColors(x)
                    END IF    
                CASE %ID_CB_COLOR      ' Color combobox
                    IF CBCTLMSG = %CBN_SELCHANGE THEN	
                        x = COMBOGETSELDATA(CBHNDL,%ID_CB_COLOROBJ)  ' Index of the selected object
                        y = COMBOGETSELDATA(CBHNDL,%ID_CB_COLOR)     ' Index of selected color
                        aCurColors(x) = y                            ' Match color to object
                        SELECT CASE x                                ' select the object and set the
                            CASE 1  ' Control BGColor                ' color with the appropriate function 
                                RMC_SetCtrlBGColor %ID_RMC2,y         
                            CASE 2  ' Caption BGColor
                                RMC_SetCaptionBGColor %ID_RMC2,1,y    
                            CASE 3  ' Caption TextColor
                                RMC_SetCaptionTextColor %ID_RMC2,1,y                                        
                            CASE 4  ' Grid Color
                                RMC_SetGridBGColor %ID_RMC2,1,y                                                                            
                            CASE 5  ' DataAxis TextColor
                                RMC_SetDaxTextColor %ID_RMC2,1,y
                            CASE 6  ' DataAxis LineColor
                                RMC_SetDaxLineColor %ID_RMC2,1,y
                            CASE 7  ' LabelAxis TextColor
                                RMC_SetLaxTextColor %ID_RMC2,1,y
                            CASE 8  ' LabelAxis LineColor
                                RMC_SetLaxLineColor %ID_RMC2,1,y   
                            CASE 9  ' Color of series 1
                                RMC_SetSeriesColor %ID_RMC2,1,1,y
                            CASE 10  ' Color of series 2
                                RMC_SetSeriesColor %ID_RMC2,1,2,y                                                                   
                        END SELECT
                        DrawCharts
                    END IF                
                CASE %ID_OPT_H,%ID_OPT_V            ' Horizontal or Vertical
                    IF CBCTLMSG = %BN_CLICKED THEN   
                        x = OptGet(CBHNDL,%ID_OPT_H,%ID_OPT_V) 
                        IF x = %ID_OPT_H THEN                  ' Horizontal
                            RMC_SetDAXAlignment %ID_RMC2,1,%RMC_DATAAXISBOTTOM  ' first dataaxis bottom
                            ' alignment of second data axis and label axis gets adjusted automatically
                            RMC_SetSeriesVertical %ID_RMC2,1,1,%FALSE            ' series 1 horizontal
                            RMC_SetSeriesVertical %ID_RMC2,1,2,%FALSE            ' series 2 horizontal
                        ELSE                                   ' Vertical 
                            RMC_SetDAXAlignment %ID_RMC2,1,%RMC_DATAAXISLEFT   ' first dataaxis left
                            ' alignment of second data axis and label axis gets adjusted automatically
                            RMC_SetSeriesVertical %ID_RMC2,1,1,%TRUE             ' series 1 vertical 
                            RMC_SetSeriesVertical %ID_RMC2,1,2,%TRUE             ' series 2 vertical
                        END IF    
                        DrawCharts
                    END IF
                CASE %ID_OPT_FH,%ID_OPT_SH        ' First half or second half
                    IF CBCTLMSG = %BN_CLICKED THEN   
                        x = OptGet(CBHNDL,%ID_OPT_FH,%ID_OPT_SH) 
                        IF x = %ID_OPT_FH THEN                   ' first half of the year
                            REDIM aData(5)
                            aData(0) = 150 : aData(1) = 300 : aData(2) = 200 : aData(3) = 400 : aData(4) = 600 : aData(5) = 800 
                            ' Set new data for the first series
                            RMC_SetSeriesData %ID_RMC2,1,1,aData(0),6
                            aData(0) = 8.9 : aData(1) = 4.1 : aData(2) = 3.88 : aData(3) = 2.1 : aData(4) = 1.3 : aData(5) = 4.3 
                            ' Set new data for the second series
                            RMC_SetSeriesData %ID_RMC2,1,2,aData(0),6
                            ' Set new labels
                            RMC_SetLaxLabels %ID_RMC2,1,"January*February*March*April*May*June"
                        ELSE
                            REDIM aData(5)
                            aData(0) = 700 : aData(1) = 450 : aData(2) = 380 : aData(3) = 520 : aData(4) = 610 : aData(5) = 420 
                            ' Set new data for the first series
                            RMC_SetSeriesData %ID_RMC2,1,1,aData(0),6
                            aData(0) = 1.9 : aData(1) = 3.8 : aData(2) = 5.2 : aData(3) = 7.4 : aData(4) = 4.5 : aData(5) = 2.3 
                            ' Set new data for the second series
                            RMC_SetSeriesData %ID_RMC2,1,2,aData(0),6
                            ' Set new labels
                            RMC_SetLaxLabels %ID_RMC2,1,"July*August*September*October*November*December"
                        END IF                    
                        DrawCharts
                    END IF    
                CASE %ID_CB_S1STYLE,%ID_CB_S2STYLE ' Style for series 1 and 2
                    IF CBCTLMSG = %CBN_SELCHANGE THEN	
                        x = COMBOGETSELDATA(CBHNDL,CBCTL)  ' Get the index of the selected object
                        IF CBCTL = %ID_CB_S1STYLE THEN
                            RMC_SetSeriesStyle %ID_RMC2,1,1,x  ' Set style for series 1
                        ELSE
                            RMC_SetSeriesStyle %ID_RMC2,1,2,x  ' Set style for series 2
                        END IF    
                        DrawCharts
                    END IF  
                CASE %ID_CHK_LUCENT ' Transparency on/off for series 1
                    RMC_SetSeriesLucent %ID_RMC2,1,1,CheckGet(CBHNDL,%ID_CHK_LUCENT) 
                    DrawCharts
                CASE %ID_CHK_S1VLABEL,%ID_CHK_S2VLABEL ' Valuelabel on/off for series 1 or 2
                    RMC_SetSeriesValuelabel %ID_RMC2,1,IIF(CBCTL=%ID_CHK_S1VLABEL,1,2),CheckGet(CBHNDL,CBCTL) 
                    DrawCharts
                CASE %ID_CHK_S1HIDE,%ID_CHK_S2HIDE ' Hide/show series 1 or 2
                    RMC_SetSeriesHide %ID_RMC2,1,IIF(CBCTL=%ID_CHK_S1HIDE,1,2),CheckGet(CBHNDL,CBCTL) 
                    DrawCharts
                CASE %ID_CHK_TOOLTIPS' Tooltips on/off
                    RMC_SetToolTipWidth %ID_RMC2, IIF(CheckGet(CBHNDL,CBCTL),50,0)
                    IF nShowClone THEN             ' if the lower chart is vivible
                        RMC_SetToolTipWidth %ID_RMC3, IIF(CheckGet(CBHNDL,CBCTL),50,0)
                    END IF    
                CASE %ID_CB_SYMBOLS ' Symbols for series 2
                    IF CBCTLMSG = %CBN_SELCHANGE THEN	
                        RMC_SetSeriesSymbol %ID_RMC2,1,2,COMBOGETSELDATA(CBHNDL,CBCTL)
                        DrawCharts
                    END IF    
                CASE %ID_CHK_CLONE     ' Show or hide the lower chart
                    nShowClone = CheckGet(CBHNDL,%ID_CHK_CLONE)  ' Get the status
                    GETCLIENTRECT CBHNDL,tRect       ' Get client rect
                    ' set the size of the upper chart, dependend on status of flag 'nShowClone'    
                    RMC_SetCtrlSize %ID_RMC2,tRect.nRight-320,tRect.nBottom-80 - IIF(nShowClone,tRect.nBottom/2-40,0),0,1
                    IF nShowClone THEN    ' if the lower chart is visible
                        ' set the lower chart size ...
                        RMC_SetCtrlSize %ID_RMC3,tRect.nRight-320,(tRect.nBottom-40) - (tRect.nBottom/2),0,1
                        DrawCharts  ' Draw both charts
                        ' Make the lower chart visible
                        RMC_SetCtrlPos %ID_RMC3,300,(tRect.nBottom/2)
                    ELSE                  ' if the lower chart is not visible        
                        RMC_SetCtrlPos %ID_RMC3,-2000,-2000  ' make it invisible (shift it's position out of the Window)
                    END IF
                CASE %ID_CMD_PRINT
                    x = OptGet(CBHNDL,%ID_OPT_JPG,%ID_OPT_EMF)
                    RMC_Draw2Printer %ID_RMC2,0,25,25,150,110,IIF(x=%ID_OPT_JPG,%RMC_BMP,%RMC_EMF)
                CASE %ID_CMD_SAVE
                    x = OptGet(CBHNDL,%ID_OPT_JPG,%ID_OPT_EMF)
                    RMC_Draw2File %ID_RMC2,"MiniDesigner."+IIF$(x=%ID_OPT_JPG,"jpg","emf")
                CASE %ID_CMD_COPY
                    x = OptGet(CBHNDL,%ID_OPT_JPG,%ID_OPT_EMF)                    
                    RMC_Draw2Clipboard %ID_RMC2,IIF(x=%ID_OPT_JPG,%RMC_BMP,%RMC_EMF)
                CASE %ID_CLOSE
                    DIALOG END CBHNDL                
                CASE %ID_INFO
                    ShowMDInfo                            
                CASE %ID_RMC2              ' the upper chart sends a message
                    SELECT CASE CBCTLMSG   ' which message
                        CASE %RMC_CTRLLBUTTONDOWN     ' Ctrl-Left mousebutton clicked
                            TINFO = CBLPARAM      ' lParam holds a pointer to a tRMC_INFO structure
                            ShowInfo @TINFO       ' Show the content of this structure                    
                        CASE %RMC_LBUTTONDOWN  ' left mousebutton pressed
                            nLBDN = 1          ' set the flag for the first series (see %RMC_MOUSEMOVE)
                        CASE %RMC_LBUTTONUP    ' left mousebutton unpressed
                            nLBDN = 0          ' remove the flag
                            nShLBDn = 0
                        CASE %RMC_MBUTTONDOWN  ' Middle mousebutton pressed
                            nMBDN = 1          ' set the flag for moving the chart (see %RMC_MOUSEMOVE)
                        CASE %RMC_MBUTTONUP    ' Middle mousebutton unpressed
                            nMBDN = 0          ' remove the flag                          
                        CASE %RMC_RBUTTONDOWN  ' right mousebutton pressed
                            TINFO = CBLPARAM      ' lParam holds a pointer to a tRMC_INFO structure
                            IF @TINFO.nGCol > 0 THEN
                               ' Set the "virtual" data for the second series (line); nDataIndex == @TINFO.nGCol
                               RMC_SetSeriesSingleData %ID_RMC2,1,2,@TINFO.nVirtData2,@TINFO.nGCol
                               DrawCharts
                            END IF                        
                        CASE %RMC_SHIFTLBUTTONDOWN
                            TINFO = CBLPARAM
                            IF @TINFO.nRegionIndex < 0 AND @TINFO.nChartType = %RMC_CO_SYMBOL THEN
                                nShLBDn = %TRUE ' Valid, if the red Bullet is clicked
                            END IF    
                        CASE %RMC_SHIFTLBUTTONUP
                            nShLBDn = 0                       
                        CASE %RMC_SHIFTRBUTTONDOWN
                            TINFO = CBLPARAM 
                            IF @TINFO.nGCol > 0 THEN  ' if clicked into a grid column
                                RMC_SetSeriesColor %ID_RMC2,1,1,%ColorRed,@TINFO.nGCol ' change the color for this bar
                                DrawCharts
                            END IF    
                        CASE %RMC_CTRLRBUTTONDOWN
                            TINFO = CBLPARAM         
                            IF @TINFO.nGCol > 0 THEN  ' if clicked into a grid column
                                RMC_SetSeriesColor %ID_RMC2,1,1,%ColorGold,@TINFO.nGCol ' change the color for this bar
                                DrawCharts
                            END IF                                
                        CASE %RMC_MOUSEMOVE    ' moving the mouse over the chart
                            TINFO = CBLPARAM      ' lParam holds a pointer to a tRMC_INFO structure
                            IF nLBDN THEN         ' if left mousebutton is pressed
                                IF @TINFO.nGCol > 0 THEN ' If the GridCol member of TINFO holds a valid value
                                    ' Set the "virtual" data for the first series (bars); nDataIndex == GridColIndex
                                    RMC_SetSeriesSingleData %ID_RMC2,1,1,@TINFO.nVirtData1,@TINFO.nGCol 
                                    DrawCharts     ' Draw the upper and the lower chart
                                END IF    
                            END IF    
                            IF nMBDN THEN  ' If Middle mousebutton is pressed
                                RMC_SetCtrlPos %ID_RMC2,@TINFO.nXMove,@TINFO.nYMove,1 ' Move the chart
                            END IF    
                            IF nShLBDn THEN ' If Shift+Left was pressed, move the red Bullet
                                RMC_COSymbol %ID_RMC2,1,@TINFO.nXPos,@TINFO.nYPos,%RMC_SYMBOL_BULLET,%ColorRed
                                DrawCharts
                            END IF    
                    END SELECT
            END SELECT    
    END SELECT
END FUNCTION        

' Create the chart initially
SUB DoTheChart(BYVAL hParent AS LONG)
    LOCAL i AS LONG
    LOCAL nC AS LONG
    LOCAL nDataCount AS LONG
    LOCAL nRetVal AS LONG
    LOCAL sTemp AS STRING
    LOCAL szTemp AS ASCIIZ * 2000
    REDIM aData(0) AS DOUBLE
    REDIM aData2(0) AS DOUBLE
    REDIM aPPC(0) AS LONG
    REDIM aColor(0) AS LONG
    LOCAL tRect AS RECT
    
    GETCLIENTRECT hParent,tRect
 
    '************** Create the chart ********************** 
    nRetVal = RMC_CreateChart(hParent,%ID_RMC2,300,10,tRect.nRight-320,tRect.nBottom-80,%ColorCornflowerBlue,%RMC_CTRLSTYLEFLAT,%FALSE,"","Tahoma")
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Region 1 ***************************** 
    nRetVal = RMC_AddRegion(%ID_RMC2,5,5,-5,-5,"this is the footer") 
    IF nRetVal < 0 THEN GOTO IsError
    
    '************** Add caption to region 1 ******************* 
    nRetVal = RMC_AddCaption(%ID_RMC2,1,"I'm the original",%ColorCoral,%ColorFloralWhite,12,%TRUE) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add grid to region 1 ***************************** 
    nRetVal = RMC_AddGrid(%ID_RMC2,1,%ColorAzure,%TRUE,0,0,0,0) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC2,1,%RMC_DATAAXISLEFT,0,1000,11,9,%ColorCornsilk,%ColorBlack,%RMC_LINESTYLESOLID,0,"","") 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add second data axis to region 1 ***************************** 
    nRetVal = RMC_AddDataAxis(%ID_RMC2,1,%RMC_DATAAXISRIGHT,0,9.7,0,0,0,0,0,2,"%","") 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add label axis to region 1 ***************************** 
    szTemp =         "January*February*March*April*May*June"
    nRetVal = RMC_AddLabelAxis(%ID_RMC2,1, szTemp,1,6,%RMC_LABELAXISBOTTOM,8,%ColorCornsilk,%RMC_TEXTCENTER,%ColorBlack,%RMC_LINESTYLESOLID,"") 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 1 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData(5)
    aData(0) = 150 : aData(1) = 300 : aData(2) = 200 : aData(3) = 400 : aData(4) = 600 : aData(5) = 800 
    nRetVal = RMC_AddBarSeries(%ID_RMC2,1,aData(0), 6,%RMC_BARSINGLE,%RMC_BAR_FLAT_GRADIENT2,%FALSE,%ColorGold,%FALSE,1,%RMC_VLABEL_NONE,1,%RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
    '************** Add Series 2 to region 1 ******************************* 
    '****** Read data values ******
    REDIM aData(5)
    aData(0) = 8.9 : aData(1) = 4.1 : aData(2) = 3.88 : aData(3) = 2.1 : aData(4) = 1.3 : aData(5) = 4.3 
    nRetVal = RMC_AddLineSeries(%ID_RMC2,1, aData(0), 6,0,0,%RMC_LINE,%RMC_LINE_CABLE,%RMC_LSTYLE_LINE,%FALSE, _
                                    %ColorGreen,%RMC_SYMBOL_BULLET,2,%RMC_VLABEL_DEFAULT,%RMC_HATCHBRUSH_OFF) 
    IF nRetVal < 0 THEN GOTO IsError
    
    RMC_COSymbol %ID_RMC2,1,(tRect.nRight-320)/2,(tRect.nBottom-80)*0.1,%RMC_SYMBOL_BULLET, %ColorRed
    
    ' Draw the upper chart initially
    nRetVal = RMC_Draw(%ID_RMC2)
    IF nRetVal < 0 THEN GOTO IsError
    
    szTemp = ""
    RMC_WriteRMCFile %ID_RMC2,szTemp  ' Get the data string from the upper chart for cloning
    RMC_CreatechartFromFile hParent,%ID_RMC3,300,315,0,szTemp ' Create a new chart from the data string of the upper chart
    ' Don't Draw() the chart, because at this moment the appropriate checkbox in the dialog is not checked


    ' Only for the User Interface: for matching the original color to the color objects
    REDIM aCurColors(1 TO 10)
    aCurColors(1)  = %ColorCornflowerBlue    'Control BGColor
    aCurColors(2)  = %ColorCoral             'Caption BGColor
    aCurColors(3)  = %ColorFloralWhite       'Caption TextColor
    aCurColors(4)  = %ColorAzure             'Grid BGColor
    aCurColors(5)  = %ColorCornsilk          'DataAxis TextColor
    aCurColors(6)  = %ColorBlack             'DataAxis LineColor
    aCurColors(7)  = %ColorCornsilk          'LabelAxis TextColor
    aCurColors(8)  = %ColorBlack             'LabelAxis LineColor
    aCurColors(9)  = %ColorGold              'Color of series 1
    aCurColors(10) = %ColorGreen             'Color of series 2
    

    EXIT SUB 
    IsError: 
END SUB


FUNCTION MiniDesigner(BYVAL hParent AS LONG) AS LONG
    LOCAL hDlg           AS DWORD
    LOCAL nDlgH&,nDlgW&,nResult&
    LOCAL nCCount&,i&,nValue&,sColor$
    LOCAL nX&,nY&

    nDlgW = 580
    nDlgH = 390

    DIALOG NEW hParent, "RMChart Demo - MiniDesigner", , , nDlgW&, nDlgH&, _
               %DS_CENTER OR %WS_SYSMENU OR %WS_MINIMIZEBOX OR %WS_MAXIMIZEBOX OR %WS_CAPTION OR %WS_THICKFRAME , _
               %WS_EX_CONTROLPARENT TO hDlg
    
    
    nX = 10 : nY = 10
    CONTROL ADD FRAME, hDlg, 10000, "Change the color",nX,nY,170,50,,
    CONTROL ADD LABEL, hDlg,10001, "Object",nX+5,nY+12,30,10
    CONTROL ADD LABEL, hDlg,10002, "Color",nX+5,nY+32,30,10
    CONTROL ADD COMBOBOX, hDlg, %ID_CB_COLOROBJ,,nX+40,nY+10,110,120,%CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
    CONTROL ADD COMBOBOX, hDlg, %ID_CB_COLOR,,nX+40,nY+30,110,120,%CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
    nCCount&=ReadColors(-1,0,sColor$)
    FOR i = 1 TO nCCount&
        nValue&=ReadColors(0,i,sColor$)
        COMBOADDLINE hDlg,%ID_CB_COLOR,sColor$,nValue&
    NEXT    
    COMBOSETINDEXDATA hDlg,%ID_CB_COLOR,%ColorCornflowerBlue
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"Control BGColor",1
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"Caption BGColor",2
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"Caption TextColor",3
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"Grid BGColor",4
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"DataAxis TextColor",5
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"DataAxis LineColor",6
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"LabelAxis TextColor",7
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"LabelAxis LineColor",8
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"Color of series 1",9
    COMBOADDLINE hDlg,%ID_CB_COLOROBJ,"Color of series 2",10
    COMBOSETINDEXDATA hDlg,%ID_CB_COLOROBJ,1
    
    nY = 63
    CONTROL ADD FRAME, hDlg, 10000, "Change chart's orientation",nX,nY,170,25,,
    CONTROL ADD OPTION, hDlg, %ID_OPT_H, "Horizontal", nX+5,nY+8,60, 14, %WS_GROUP OR %WS_TABSTOP
    CONTROL ADD OPTION, hDlg, %ID_OPT_V, "Vertical",nX+80, nY+8, 60, 14
    CONTROL SET OPTION hDlg, %ID_OPT_V, %ID_OPT_H,%ID_OPT_V
    
    nY = 91
    CONTROL ADD FRAME, hDlg, 10000, "Choose the period",nX,nY,170,25,,
    CONTROL ADD OPTION, hDlg, %ID_OPT_FH, "First half of year", nX+5,nY+8,70, 14, %WS_GROUP OR %WS_TABSTOP
    CONTROL ADD OPTION, hDlg, %ID_OPT_SH, "Second half of year",nX+80, nY+8, 80, 14
    CONTROL SET OPTION hDlg, %ID_OPT_FH, %ID_OPT_FH,%ID_OPT_SH
    
    nY = 119
    CONTROL ADD FRAME, hDlg, 10000, "Tooltips",nX,nY,170,25,,
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_TOOLTIPS,"Enable ToolTips for the datapoints",nX+5,nY+9,130,11
    
    nY = 147
    CONTROL ADD FRAME, hDlg, 10000, "Series 1",nX,nY,170,60,,
    CONTROL ADD LABEL, hDlg, 10001, "Style",nX+5,nY+12,30,10
    CONTROL ADD COMBOBOX, hDlg, %ID_CB_S1STYLE,,nX+40,nY+10,110,120,%CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Flat",%RMC_BAR_FLAT 
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Flat, gradient style 1",%RMC_BAR_FLAT_GRADIENT1
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Flat, gradient style 2",%RMC_BAR_FLAT_GRADIENT2
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Hover",%RMC_BAR_HOVER
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"3D",%RMC_BAR_3D
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"3D, gradient style",%RMC_BAR_3D_GRADIENT
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Column flat",%RMC_COLUMN_FLAT
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Column 3D",%RMC_COLUMN_3D
    COMBOADDLINE hDlg,%ID_CB_S1STYLE,"Column 3D, gradient style",%RMC_COLUMN_3D_GRADIENT
    COMBOSETINDEXDATA hDlg,%ID_CB_S1STYLE,%RMC_BAR_FLAT_GRADIENT2
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_LUCENT,"Transparency on",nX+5,nY+25,70,11
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_S1VLABEL,"Show value label",nX+5,nY+35,70,11
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_S1HIDE,"Hide series",nX+5,nY+45,70,11



    nY = 210
    CONTROL ADD FRAME, hDlg, 10000, "Series 2",nX,nY,170,69,,
    CONTROL ADD LABEL, hDlg, 10001, "Style",nX+5,nY+12,30,10
    CONTROL ADD COMBOBOX, hDlg, %ID_CB_S2STYLE,,nX+40,nY+10,110,120,%CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Flat Solid",%RMC_LINE_FLAT 
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Flat Dot",%RMC_LINE_FLAT_DOT
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Flat Dash",%RMC_LINE_FLAT_DASH
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Flat DashDot",%RMC_LINE_FLAT_DASHDOT
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Flat DashDotDot",%RMC_LINE_FLAT_DASHDOTDOT    
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Cable",%RMC_LINE_CABLE
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"Cable with shadow",%RMC_LINE_CABLE_SHADOW
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"No line, only symbols",%RMC_LINE_SYMBOLONLY
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"3D",%RMC_LINE_3D
    COMBOADDLINE hDlg,%ID_CB_S2STYLE,"3D, gradient style",%RMC_LINE_3D_GRADIENT
    COMBOSETINDEXDATA hDlg,%ID_CB_S2STYLE,%RMC_LINE_CABLE
    CONTROL ADD LABEL, hDlg, %ID_LBL_SYMBOLS, "Symbols",nX+5,nY+30,30,10
    CONTROL ADD COMBOBOX, hDlg, %ID_CB_SYMBOLS,,nX+40,nY+28,110,120,%CBS_DROPDOWNLIST OR %WS_TABSTOP OR %WS_VSCROLL OR %CBS_DISABLENOSCROLL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"No symbol",%RMC_SYMBOL_NONE 
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Bullet",%RMC_SYMBOL_BULLET
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Point",%RMC_SYMBOL_POINT
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Diamond",%RMC_SYMBOL_DIAMOND
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Square",%RMC_SYMBOL_SQUARE
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Star",%RMC_SYMBOL_STAR
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Arrow down",%RMC_SYMBOL_ARROW_DOWN
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Arrow up",%RMC_SYMBOL_ARROW_UP
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Circle",%RMC_SYMBOL_CIRCLE
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Rectangle",%RMC_SYMBOL_RECTANGLE
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Cross",%RMC_SYMBOL_CROSS
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Bullet small",%RMC_SYMBOL_BULLET_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Point small",%RMC_SYMBOL_POINT_SMALL 
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Diamond small",%RMC_SYMBOL_DIAMOND_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Square small",%RMC_SYMBOL_SQUARE_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Star small",%RMC_SYMBOL_STAR_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Arrow down small",%RMC_SYMBOL_ARROW_DOWN_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Arrow up small",%RMC_SYMBOL_ARROW_UP_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Circle small",%RMC_SYMBOL_CIRCLE_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Rectangle small",%RMC_SYMBOL_RECTANGLE_SMALL
    COMBOADDLINE hDlg,%ID_CB_SYMBOLS,"Cross small",%RMC_SYMBOL_CROSS_SMALL        
    COMBOSETINDEXDATA hDlg,%ID_CB_SYMBOLS,%RMC_SYMBOL_BULLET
    
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_S2VLABEL,"Show value label",nX+5,nY+45,70,11
    CheckSet hDlg,%ID_CHK_S2VLABEL, 1
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_S2HIDE,"Hide series",nX+5,nY+55,70,11
    
    nY = 282
    CONTROL ADD FRAME, hDlg, 10000, "Show/Hide second chart",nX,nY,170,25,,
    CONTROL ADD CHECKBOX, hDlg,%ID_CHK_CLONE,"Show the cloned chart",nX+5,nY+9,120,11
    
    nY = 312
    CONTROL ADD FRAME, hDlg, 10000, "Print/Save/Copy to Clipboard the upper chart",nX,nY,170,50,,
    CONTROL ADD OPTION, hDlg, %ID_OPT_JPG, "As Bitmap", nX+5,nY+8,70, 14, %WS_GROUP OR %WS_TABSTOP
    CONTROL ADD OPTION, hDlg, %ID_OPT_EMF, "As EMF",nX+80, nY+8, 80, 14
    CONTROL SET OPTION hDlg, %ID_OPT_JPG, %ID_OPT_JPG,%ID_OPT_EMF
    CONTROL ADD BUTTON, hDlg, %ID_CMD_PRINT,"&Print",nX+5,nY+25,50,15
    CONTROL ADD BUTTON, hDlg, %ID_CMD_SAVE,"&Save",nX+60,nY+25,50,15
    CONTROL ADD BUTTON, hDlg, %ID_CMD_COPY,"&Copy",nX+115,nY+25,50,15    
    
    CONTROL ADD BUTTON, hDlg, %ID_CLOSE,"&Close",nX,367,50,15
    CONTROL ADD BUTTON, hDlg, %ID_INFO,"&Info",nX+120,367,50,15
    
    DoTheChart hDlg               
    DIALOG SHOW MODAL hDlg, CALL MDCallback TO nResult           
END FUNCTION


' ******** Helper functions for the MiniDesigner ********************
FUNCTION ReadColors(BYVAL nMode AS LONG, BYVAL nIndex AS LONG, BYREF sName AS STRING) AS LONG
    LOCAL i&,nC&,nColor&
    DATA %ColorAliceBlue=&HFFF0F8FF,%ColorAntiqueWhite=&HFFFAEBD7,%ColorAquamarine=&HFF7FFFD4,%ColorArmyGreen=&HFF669966
    DATA %ColorAutumnOrange=&HFFFF6633,%ColorAvocadoGreen=&HFF669933,%ColorAzure=&HFFF0FFFF,%ColorBabyBlue=&HFF6699FF
    DATA %ColorBananaYellow=&HFFCCCC33,%ColorBeige=&HFFF5F5DC,%ColorBisque=&HFFFFE4C4,%ColorBlack=&HFF000000
    DATA %ColorBlanchedAlmond=&HFFFFEBCD,%ColorBlue=&HFF0000FF,%ColorBlueViolet=&HFF8A2BE2,%ColorBrown=&HFFA52A2A
    DATA %ColorBurlyWood=&HFFDEB887,%ColorCadetBlue=&HFF5F9EA0,%ColorChalk=&HFFFFFF99,%ColorChartreuse=&HFF7FFF00
    DATA %ColorChocolate=&HFFD2691E,%ColorCoral=&HFFFF7F50,%ColorCornflowerBlue=&HFF6495ED,%ColorCornsilk=&HFFFFF8DC
    DATA %ColorCrimson=&HFFDC143C,%ColorCyan=&HFF00FFFF,%ColorDarkBlue=&HFF00008B,%ColorDarkBrown=&HFF663333
    DATA %ColorDarkCrimson=&HFF993366,%ColorDarkCyan=&HFF008B8B,%ColorDarkGold=&HFFCC9933,%ColorDarkGoldenrod=&HFFB8860B
    DATA %ColorDarkGray=&HFFA9A9A9,%ColorDarkGreen=&HFF006400,%ColorDarkKhaki=&HFFBDB76B,%ColorDarkMagenta=&HFF8B008B
    DATA %ColorDarkOliveGreen=&HFF556B2F,%ColorDarkOrange=&HFFFF8C00,%ColorDarkOrchid=&HFF9932CC,%ColorDarkRed=&HFF8B0000
    DATA %ColorDarkSalmon=&HFFE9967A,%ColorDarkSeaGreen=&HFF8FBC8B,%ColorDarkSlateBlue=&HFF483D8B,%ColorDarkSlateGray=&HFF2F4F4F
    DATA %ColorDarkTurquoise=&HFF00CED1,%ColorDarkViolet=&HFF9400D3,%ColorDeepAzure=&HFF6633FF,%ColorDeepPink=&HFFFF1493
    DATA %ColorDeepPurple=&HFF330066,%ColorDeepRiver=&HFF6600CC,%ColorDeepRose=&HFFCC3399,%ColorDeepSkyBlue=&HFF00BFFF
    DATA %ColorDefault=0,%ColorDeepYellow=&HFFFFCC00,%ColorDesertBlue=&HFF336699,%ColorDimGray=&HFF696969,%ColorDodgerBlue=&HFF1E90FF
    DATA %ColorDullGreen=&HFF99CC66,%ColorEasterPurple=&HFFCC99FF,%ColorFadeGreen=&HFF99CC99,%ColorFirebrick=&HFFB22222
    DATA %ColorFloralWhite=&HFFFFFAF0,%ColorForestGreen=&HFF228B22,%ColorGainsboro=&HFFDCDCDC,%ColorGhostGreen=&HFFCCFFCC
    DATA %ColorGhostWhite=&HFFF8F8FF,%ColorGold=&HFFFFD700,%ColorGoldenrod=&HFFDAA520,%ColorGrape=&HFF663399
    DATA %ColorGrassGreen=&HFF009933,%ColorGray=&HFF808080,%ColorGreen=&HFF008000,%ColorGreenYellow=&HFFADFF2F
    DATA %ColorHoneydew=&HFFF0FFF0,%ColorHotPink=&HFFFF69B4,%ColorIndianRed=&HFFCD5C5C,%ColorIndigo=&HFF4B0082
    DATA %ColorIvory=&HFFFFFFF0,%ColorKentuckyGreen=&HFF339966,%ColorKhaki=&HFFF0E68C,%ColorLavender=&HFFE6E6FA
    DATA %ColorLavenderBlush=&HFFFFF0F5,%ColorLawnGreen=&HFF7CFC00,%ColorLemonChiffon=&HFFFFFACD,%ColorLightBlue=&HFFADD8E6
    DATA %ColorLightCoral=&HFFF08080,%ColorLightCyan=&HFFE0FFFF,%ColorLightGoldenrod=&HFFEEDD82,%ColorLightGoldenrodYellow=&HFFFAFAD2
    DATA %ColorLightGray=&HFFD3D3D3,%ColorLightGreen=&HFF90EE90,%ColorLightOrange=&HFFFF9933,%ColorLightPink=&HFFFFB6C1
    DATA %ColorLightSalmon=&HFFFFA07A,%ColorLightSeaGreen=&HFF20B2AA,%ColorLightSkyBlue=&HFF87CEFA,%ColorLightSlateGray=&HFF778899
    DATA %ColorLightSteelBlue=&HFFB0C4DE,%ColorLightViolet=&HFFFF99FF,%ColorLightYellow=&HFFFFFFE0,%ColorLime=&HFF00FF00
    DATA %ColorLimeGreen=&HFF32CD32,%ColorLinen=&HFFFAF0E6,%ColorMagenta=&HFFFF00FF,%ColorMaroon=&HFF800000
    DATA %ColorMartianGreen=&HFF99CC33,%ColorMediumAquamarine=&HFF66CDAA,%ColorMediumBlue=&HFF0000CD,%ColorMediumOrchid=&HFFBA55D3
    DATA %ColorMediumPurple=&HFF9370DB,%ColorMediumSeaGreen=&HFF3CB371,%ColorMediumSlateBlue=&HFF7B68EE,%ColorMediumSpringGreen=&HFF00FA9A
    DATA %ColorMediumTurquoise=&HFF48D1CC,%ColorMediumVioletRed=&HFFC71585,%ColorMidnightBlue=&HFF191970
    DATA %ColorMintCream=&HFFF5FFFA,%ColorMistyRose=&HFFFFE4E1,%ColorMoccasin=&HFFFFE4B5,%ColorMoonGreen=&HFFCCFF66
    DATA %ColorMossGreen=&HFF336666,%ColorNavajoWhite=&HFFFFDEAD,%ColorNavy=&HFF000080,%ColorOceanGreen=&HFF669999
    DATA %ColorOldLace=&HFFFDF5E6,%ColorOlive=&HFF808000,%ColorOliveDrab=&HFF6B8E23,%ColorOrange=&HFFFFA500
    DATA %ColorOrangeRed=&HFFFF4500,%ColorOrchid=&HFFDA70D6,%ColorPaleGoldenrod=&HFFEEE8AA,%ColorPaleGreen=&HFF98FB98
    DATA %ColorPaleTurquoise=&HFFAFEEEE,%ColorPaleVioletRed=&HFFDB7093,%ColorPaleYellow=&HFFFFFFCC,%ColorPapayaWhip=&HFFFFEFD5
    DATA %ColorPeachPuff=&HFFFFDAB9,%ColorPeru=&HFFCD853F,%ColorPink=&HFFFFC0CB,%ColorPlum=&HFFDDA0DD,%ColorPowderBlue=&HFFB0E0E6
    DATA %ColorPurple=&HFF800080,%ColorRed=&HFFFF0000,%ColorRosyBrown=&HFFBC8F8F,%ColorRoyalBlue=&HFF4169E1
    DATA %ColorSaddleBrown=&HFF8B4513,%ColorSalmon=&HFFFA8072,%ColorSand=&HFFFFCC99,%ColorSandyBrown=&HFFF4A460
    DATA %ColorSeaGreen=&HFF2E8B57,%ColorSeaShell=&HFFFFF5EE,%ColorSienna=&HFFA0522D,%ColorSilver=&HFFC0C0C0
    DATA %ColorSkyBlue=&HFF87CEEB,%ColorSlateBlue=&HFF6A5ACD,%ColorSlateGray=&HFF708090,%ColorSnow=&HFFFFFAFA
    DATA %ColorSpringGreen=&HFF00FF7F,%ColorSteelBlue=&HFF4682B4,%ColorTan=&HFFD2B48C,%ColorTeal=&HFF008080
    DATA %ColorThistle=&HFFD8BFD8,%ColorTomato=&HFFFF6347,%ColorTransparent=&HFFFFFFFE,%ColorTropicalPink=&HFFFF6666,%ColorTurquoise=&HFF40E0D0
    DATA %ColorViolet=&HFFEE82EE,%ColorVioletRed=&HFFD02090,%ColorWalnut=&HFF663300,%ColorWheat=&HFFF5DEB3
    DATA %ColorWhite=&HFFFFFFFF,%ColorWhiteSmoke=&HFFF5F5F5,%ColorYellow=&HFFFFFF00,%ColorYellowGreen=&HFF9ACD32
    
    IF nMode = -1 THEN         ' Colorcount                       
    	FUNCTION = DATACOUNT
    ELSEIF nMode = 0 THEN      ' Name and Value
    	sName = LTRIM$(PARSE$(READ$(nIndex),"=",1),"%Color")
    	FUNCTION = VAL(PARSE$(READ$(nIndex),"=",2))
    END IF	
END FUNCTION   

FUNCTION COMBOADDLINE (BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG, _
                                           BYVAL sText AS STRING, OPTIONAL BYVAL nData AS LONG) AS LONG
    LOCAL hCombo    AS LONG
    LOCAL nIndex    AS LONG
    hCombo = GETDLGITEM(nDialogHandle, nCtrlID)
    nIndex = SENDMESSAGE(hCombo, %CB_ADDSTRING, 0, STRPTR(sText))
    CALL SENDMESSAGE(hCombo, %CB_SETITEMDATA, nIndex, nData)
    FUNCTION = nIndex
END FUNCTION
SUB COMBOSETINDEXDATA(BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG, BYVAL nData AS LONG)
    REGISTER i&
    LOCAL nCount&,hCombo&
    hCombo = GETDLGITEM(nDialogHandle,nCtrlID)
    nCount = SENDMESSAGE(hCombo, %CB_GETCOUNT, 0, 0)
    FOR i = 0 TO nCount-1
        IF nData = SENDMESSAGE(hCombo, %CB_GETITEMDATA, i, 0) THEN
            SENDMESSAGE hCombo,%CB_SETCURSEL,i,0
            EXIT SUB
        END IF
    NEXT
    SENDMESSAGE hCombo,%CB_SETCURSEL,0,0                
END SUB    
FUNCTION COMBOGETSELINDEX (BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG) AS LONG
    LOCAL hCombo    AS LONG
    hCombo = GETDLGITEM(nDialogHandle, nCtrlID)
    FUNCTION = SENDMESSAGE(hCombo, %CB_GETCURSEL, 0, 0)
END FUNCTION
FUNCTION COMBOGETSELDATA (BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG) AS LONG
    LOCAL hCombo    AS LONG
    hCombo = GETDLGITEM(nDialogHandle, nCtrlID)
    FUNCTION = SENDMESSAGE(hCombo, %CB_GETITEMDATA, COMBOGETSELINDEX(nDialogHandle, nCtrlID), 0)
END FUNCTION
FUNCTION CheckGet(BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG) AS LONG
    LOCAL nTemp AS LONG
    CONTROL GET CHECK nDialogHandle, nCtrlID TO nTemp
    FUNCTION = nTemp
END FUNCTION
SUB CheckSet(BYVAL nDialogHandle AS LONG, BYVAL nCtrlID AS LONG,BYVAL nState AS LONG)
    LOCAL nTemp AS LONG
    CONTROL SET CHECK nDialogHandle, nCtrlID, nState
END SUB
FUNCTION OptGet(BYVAL hDlg AS LONG, BYVAL nLower AS LONG, BYVAL nUpper AS LONG) AS LONG
    LOCAL i         AS LONG
    LOCAL nOpt      AS LONG
    FOR i=nLower TO nUpper
        CONTROL GET CHECK hdlg,i TO nOpt
        IF nOpt=1 THEN
            nOpt = i
            EXIT FOR
        END IF
    NEXT
    FUNCTION = nOpt
END FUNCTION
FUNCTION TRIM(BYVAL sText AS STRING) AS STRING
    FUNCTION = TRIM$(REMOVE$(sText,CHR$(0)))
END FUNCTION    